import { inject as ae, ref as L, onMounted as Ai, watch as sn, provide as We, watchEffect as qe, watchPostEffect as xn, defineComponent as M, computed as F, createVNode as t, createTextVNode as $, Fragment as X, onUnmounted as Mi } from "vue";
import { createLowlight as Ri, all as Oi } from "lowlight";
var je;
(function(e) {
  e.None = "None", e.Up = "Up", e.Down = "Down", e.Both = "Both", e.Short = "Short";
})(je || (je = {}));
class ji {
  /**
   * @param header The details from the diff hunk header about the line start and patch length.
   * @param lines The contents - context and changes - of the diff section.
   * @param unifiedDiffStart The diff hunk's start position in the overall file diff.
   * @param unifiedDiffEnd The diff hunk's end position in the overall file diff.
   */
  constructor(n, i, d, l, s) {
    this.header = n, this.lines = i, this.unifiedDiffStart = d, this.unifiedDiffEnd = l, this.expansionType = s;
  }
  equals(n) {
    return this === n ? !0 : this.header.equals(n.header) && this.unifiedDiffStart === n.unifiedDiffStart && this.unifiedDiffEnd === n.unifiedDiffEnd && this.expansionType === n.expansionType && this.lines.length === n.lines.length && this.lines.every((i, d) => i.equals(n.lines[d]));
  }
}
class Bi {
  /**
   * @param oldStartLine The line in the old (or original) file where this diff hunk starts.
   * @param oldLineCount The number of lines in the old (or original) file that this diff hunk covers
   * @param newStartLine The line in the new file where this diff hunk starts.
   * @param newLineCount The number of lines in the new file that this diff hunk covers.
   */
  constructor(n, i, d, l) {
    this.oldStartLine = n, this.oldLineCount = i, this.newStartLine = d, this.newLineCount = l;
  }
  toDiffLineRepresentation() {
    return `@@ -${this.oldStartLine},${this.oldLineCount} +${this.newStartLine},${this.newLineCount} @@`;
  }
  equals(n) {
    return this.oldStartLine === n.oldStartLine && this.oldLineCount === n.oldLineCount && this.newStartLine === n.newStartLine && this.oldStartLine === n.oldStartLine;
  }
}
var T;
(function(e) {
  e[e.CRLF = 1] = "CRLF", e[e.CR = 2] = "CR", e[e.LF = 3] = "LF", e[e.NEWLINE = 4] = "NEWLINE";
})(T || (T = {}));
const Ti = 1e3;
function jn(e) {
  return e.location + e.length;
}
function Bn(e, n, i, d, l) {
  const s = Math.min(n.length, d.length), u = l ? jn(n) - 1 : n.location, a = l ? jn(d) - 1 : d.location, v = l ? -1 : 1;
  let o = 0;
  for (; Math.abs(o) < s && e[u + o] === i[a + o]; )
    o += v;
  return Math.abs(o);
}
function Tn(e) {
  return e.trim().length === 0 || e.length >= Ti;
}
function Kn(e, n) {
  const i = e.text, d = n.text;
  let l = { location: 0, length: d.length }, s = { location: 0, length: i.length };
  const u = i.trimEnd(), a = d.trimEnd(), v = i.slice(-2), o = d.slice(-2), c = e.noTrailingNewLine !== n.noTrailingNewLine, f = v === `\r
` ? T.CRLF : v.endsWith("\r") ? T.CR : T.LF, h = o === `\r
` ? T.CRLF : o.endsWith("\r") ? T.CR : T.LF;
  if (u === a && (c || f !== h))
    return {
      stringARange: {
        location: u.length,
        length: i.length - u.length,
        newLineSymbol: c ? T.NEWLINE : f
      },
      stringBRange: {
        location: a.length,
        length: d.length - a.length,
        newLineSymbol: c ? T.NEWLINE : h
      }
    };
  if (Tn(i) || Tn(d))
    return s.length = 0, l.length = 0, { stringARange: s, stringBRange: l };
  const w = Bn(d, l, i, s, !1);
  l = {
    location: l.location + w,
    length: l.length - w
  }, s = {
    location: s.location + w,
    length: s.length - w
  };
  const m = Bn(d, l, i, s, !0);
  return l.length -= m, s.length -= m, { stringARange: s, stringBRange: l };
}
function Ui(e, n) {
  const i = e.text.trim(), d = n.text.trim(), l = e.clone(i), s = n.clone(d), { stringARange: u, stringBRange: a } = Kn(l, s);
  return u.location > 0 || a.location > 0 || u.length < i.length || a.length < d.length;
}
var C;
(function(e) {
  e[e.Context = 0] = "Context", e[e.Add = 1] = "Add", e[e.Delete = 2] = "Delete", e[e.Hunk = 3] = "Hunk";
})(C || (C = {}));
class ve {
  constructor(n, i, d, l, s, u = !1, a = !1, v) {
    this.text = n, this.type = i, this.originalLineNumber = d, this.oldLineNumber = l, this.newLineNumber = s, this.noTrailingNewLine = u, this.needRematch = a, this.range = v;
  }
  withNoTrailingNewLine(n) {
    return new ve(this.text, this.type, this.originalLineNumber, this.oldLineNumber, this.newLineNumber, n);
  }
  isIncludeableLine() {
    return this.type === C.Add || this.type === C.Delete;
  }
  /** The content of the line, i.e., without the line type marker. */
  get content() {
    return this.text.substring(1);
  }
  equals(n) {
    return this.text === n.text && this.type === n.type && this.originalLineNumber === n.originalLineNumber && this.oldLineNumber === n.oldLineNumber && this.newLineNumber === n.newLineNumber && this.noTrailingNewLine === n.noTrailingNewLine;
  }
  clone(n) {
    return new ve(n, this.type, this.originalLineNumber, this.oldLineNumber, this.newLineNumber);
  }
}
const be = (e) => e ? e.type === C.Add || e.type === C.Delete : !1, Pi = 40;
function Vi(e, n) {
  throw new Error(n);
}
function Gi(e) {
  var n, i;
  if (e.length === 0)
    return 0;
  for (let d = e.length - 1; d >= 0; d--) {
    const l = e[d];
    for (let s = l.lines.length - 1; s >= 0; s--) {
      const u = l.lines[s];
      if (u.type === C.Hunk)
        continue;
      const a = (n = u.newLineNumber) !== null && n !== void 0 ? n : 0, v = (i = u.oldLineNumber) !== null && i !== void 0 ? i : 0;
      return a > v ? a : v;
    }
  }
  return 0;
}
function zi(e, n, i) {
  const d = i === null ? 1 / 0 : n.oldStartLine - i.header.oldStartLine - i.header.oldLineCount;
  return e === 0 ? n.oldStartLine > 1 && n.newStartLine > 1 ? je.Up : je.None : d <= Pi ? je.Short : je.Both;
}
const Xn = (e, n) => {
  const i = [];
  for (let d = 0; d < e; d++)
    i.push(n(d));
  return i;
}, Un = (e) => {
  const n = e.lastIndexOf(".");
  return e.slice(n + 1);
}, Pn = (e, n) => {
  if (e.length === n.length) {
    const i = e.length;
    for (let d = 0; d < i; d++) {
      const l = e[d], s = n[d];
      if (Ui(l, s)) {
        const { stringARange: a, stringBRange: v } = Kn(l, s);
        l.needRematch = !0, l.range = a, s.needRematch = !0, s.range = v;
      }
    }
  }
}, Zi = /^@@ -(\d+)(?:,(\d+))? \+(\d+)(?:,(\d+))? @@/, qi = /[\u202A-\u202E]|[\u2066-\u2069]/, Jn = "+", Qn = "-", Yn = " ", ei = "\\", Ki = /* @__PURE__ */ new Set([
  Jn,
  Qn,
  Yn,
  ei
]);
class Xi {
  constructor() {
    Object.defineProperty(this, "__v_skip", { value: !0 }), this.reset();
  }
  /**
   * Resets the internal parser state so that it can be reused.
   *
   * This is done automatically at the end of each parse run.
   */
  reset() {
    this.ls = 0, this.le = -1, this.text = "";
  }
  /**
   * Aligns the internal character pointers at the boundaries of
   * the next line.
   *
   * Returns true if successful or false if the end of the diff
   * has been reached.
   */
  nextLine() {
    return this.ls = this.le + 1, this.ls >= this.text.length ? !1 : (this.le = this.text.indexOf(`
`, this.ls), this.le === -1 && (this.le = this.text.length), this.ls !== this.le);
  }
  /**
   * Advances to the next line and returns it as a substring
   * of the raw diff text. Returns null if end of diff was
   * reached.
   */
  readLine(n) {
    return n ? this.nextLine() ? this.text.substring(this.ls, this.le) : null : this.nextLine() ? this.text.substring(this.ls + 1, this.le + 1) : null;
  }
  /** Tests if the current line starts with the given search text */
  lineStartsWith(n) {
    return this.text.startsWith(n, this.ls);
  }
  /** Tests if the current line ends with the given search text */
  lineEndsWith(n) {
    return this.text.endsWith(n, this.le);
  }
  /**
   * Returns the starting character of the next line without
   * advancing the internal state. Returns null if advancing
   * would mean reaching the end of the diff.
   */
  peek() {
    const n = this.le + 1;
    return n < this.text.length ? this.text[n] : null;
  }
  /**
   * Parse the diff header, meaning everything from the
   * start of the diff output to the end of the line beginning
   * with +++
   *
   * Example diff header:
   *
   *   diff --git a/app/src/lib/diff-parser.ts b/app/src/lib/diff-parser.ts
   *   index e1d4871..3bd3ee0 100644
   *   --- a/app/src/lib/diff-parser.ts
   *   +++ b/app/src/lib/diff-parser.ts
   *
   * Returns an object with information extracted from the diff
   * header (currently whether it's a binary patch) or null if
   * the end of the diff was reached before the +++ line could be
   * found (which is a valid state).
   */
  parseDiffHeader() {
    for (; this.nextLine(); ) {
      if (this.lineStartsWith("Binary files ") && this.lineEndsWith("differ"))
        return { isBinary: !0 };
      if (this.lineStartsWith("+++"))
        return { isBinary: !1 };
    }
    return null;
  }
  /**
   * Attempts to convert a RegExp capture group into a number.
   * If the group doesn't exist or wasn't captured the function
   * will return the value of the defaultValue parameter or throw
   * an error if no default value was provided. If the captured
   * string can't be converted to a number an error will be thrown.
   */
  numberFromGroup(n, i, d = null) {
    const l = n[i];
    if (!l) {
      if (!d)
        throw new Error(`Group ${i} missing from regexp match and no defaultValue was provided`);
      return d;
    }
    const s = parseInt(l, 10);
    if (isNaN(s))
      throw new Error(`Could not parse capture group ${i} into number: ${l}`);
    return s;
  }
  /**
   * Parses a hunk header or throws an error if the given line isn't
   * a well-formed hunk header.
   *
   * We currently only extract the line number information and
   * ignore any hunk headings.
   *
   * Example hunk header (text within ``):
   *
   * `@@ -84,10 +82,8 @@ export function parseRawDiff(lines: ReadonlyArray<string>): Diff {`
   *
   * Where everything after the last @@ is what's known as the hunk, or section, heading
   */
  parseHunkHeader(n) {
    const i = Zi.exec(n);
    if (!i)
      throw new Error("Invalid hunk header format");
    const d = this.numberFromGroup(i, 1), l = this.numberFromGroup(i, 2, 1), s = this.numberFromGroup(i, 3), u = this.numberFromGroup(i, 4, 1);
    return new Bi(d, l, s, u);
  }
  /**
   * Convenience function which lets us leverage the type system to
   * prove exhaustive checks in parseHunk.
   *
   * Takes an arbitrary string and checks to see if the first character
   * of that string is one of the allowed prefix characters for diff
   * lines (ie lines in between hunk headers).
   */
  parseLinePrefix(n) {
    return n && n.length && Ki.has(n[0]) ? n[0] : null;
  }
  /**
   * Parses a hunk, including its header or throws an error if the diff doesn't
   * contain a well-formed diff hunk at the current position.
   *
   * Expects that the position has been advanced to the beginning of a presumed
   * diff hunk header.
   *
   * @param linesConsumed The number of unified diff lines consumed up until
   *                      this point by the diff parser. Used to give the
   *                      position and length (in lines) of the parsed hunk
   *                      relative to the overall parsed diff. These numbers
   *                      have no real meaning in the context of a diff and
   *                      are only used to aid the app in line-selections.
   */
  parseHunk(n, i, d) {
    const l = this.readLine(!0);
    if (!l)
      throw new Error("Expected hunk header but reached end of diff");
    const s = this.parseHunkHeader(l), u = new Array();
    u.push(new ve(l, C.Hunk, 1, null, null));
    let a, v = s.oldStartLine, o = s.newStartLine, c = n;
    for (; a = this.parseLinePrefix(this.peek()); ) {
      const f = this.readLine(!1);
      if (c++, !f)
        throw new Error("Expected unified diff line but reached end of diff");
      if (a === ei) {
        if (f.length < 12)
          throw new Error('Expected "no newline at end of file" marker to be at least 12 bytes long');
        const w = u.length - 1, m = u[w];
        u[w] = m.withNoTrailingNewLine(!0);
        continue;
      }
      let h;
      if (a === Jn)
        h = new ve(f, C.Add, c, null, o++);
      else if (a === Qn)
        h = new ve(f, C.Delete, c, v++, null);
      else if (a === Yn)
        h = new ve(f, C.Context, c, v++, o++);
      else
        return Vi(a, `Unknown DiffLinePrefix: ${a}`);
      u.push(h);
    }
    if (u.length === 1)
      throw new Error("Malformed diff, empty hunk");
    return new ji(s, u, n, n + u.length - 1, zi(i, s, d));
  }
  /**
   * Parse a well-formed unified diff into hunks and lines.
   *
   * @param text A unified diff produced by git diff, git log --patch
   *             or any other git plumbing command that produces unified
   *             diffs.
   */
  parse(n) {
    this.text = n;
    try {
      const i = this.parseDiffHeader(), d = this.le, l = this.text.substring(0, d);
      if (!i)
        return {
          header: l,
          contents: "",
          hunks: [],
          isBinary: !1,
          maxLineNumber: 0,
          hasHiddenBidiChars: !1
        };
      if (i.isBinary)
        return {
          header: l,
          contents: "",
          hunks: [],
          isBinary: !0,
          maxLineNumber: 0,
          hasHiddenBidiChars: !1
        };
      const s = new Array();
      let u = 0, a = null;
      do {
        const o = this.parseHunk(u, s.length, a);
        s.push(o), a = o, u += o.lines.length;
      } while (this.peek());
      const v = this.text.substring(d + 1, this.le).replace(/\n\\ No newline at end of file/g, "");
      return {
        header: l,
        contents: v,
        hunks: s,
        isBinary: i.isBinary,
        maxLineNumber: Gi(s),
        hasHiddenBidiChars: qi.test(n)
      };
    } finally {
      this.reset();
    }
  }
}
const Ji = new Xi();
function r(e, n, i, d) {
  if (i === "a" && !d)
    throw new TypeError("Private accessor was defined without a getter");
  if (typeof n == "function" ? e !== n || !d : !n.has(e))
    throw new TypeError("Cannot read private member from an object whose class did not declare it");
  return i === "m" ? d : i === "a" ? d.call(e) : d ? d.value : n.get(e);
}
function I(e, n, i, d, l) {
  if (d === "m")
    throw new TypeError("Private method is not writable");
  if (d === "a" && !l)
    throw new TypeError("Private accessor was defined without a setter");
  if (typeof n == "function" ? e !== n || !l : !n.has(e))
    throw new TypeError("Cannot write private member to an object whose class did not declare it");
  return d === "a" ? l.call(e, i) : l ? l.value = i : n.set(e, i), i;
}
const Qi = (e) => {
  let n = 1;
  const i = {}, d = (l, s) => {
    l.forEach((u) => {
      if (u.type === "text") {
        if (u.value.indexOf(`
`) === -1) {
          const v = u.value.length;
          if (i[n])
            u.startIndex = i[n].valueLength, u.endIndex = u.startIndex + v - 1, i[n].value += u.value, i[n].valueLength += v, i[n].nodeList.push({ node: u, wrapper: s });
          else {
            u.startIndex = 0, u.endIndex = v - 1;
            const o = {
              value: u.value,
              lineNumber: n,
              valueLength: v,
              nodeList: [{ node: u, wrapper: s }]
            };
            i[n] = o;
          }
          u.lineNumber = n;
          return;
        }
        const a = u.value.split(`
`);
        u.children = u.children || [];
        for (let v = 0; v < a.length; v++) {
          const o = v === a.length - 1 ? a[v] : a[v] + `
`, c = v === 0 ? n : ++n, f = o.length, h = {
            type: "text",
            value: o,
            startIndex: 1 / 0,
            endIndex: 1 / 0,
            lineNumber: c
          };
          if (i[c])
            h.startIndex = i[c].valueLength, h.endIndex = h.startIndex + f - 1, i[c].value += o, i[c].valueLength += f, i[c].nodeList.push({ node: h, wrapper: s });
          else {
            h.startIndex = 0, h.endIndex = f - 1;
            const w = {
              value: o,
              lineNumber: c,
              valueLength: f,
              nodeList: [{ node: h, wrapper: s }]
            };
            i[c] = w;
          }
          u.children.push(h);
        }
        u.lineNumber = n;
        return;
      }
      u.children && (d(u.children, u), u.lineNumber = n);
    });
  };
  return d(e.children), { syntaxFileObject: i, syntaxFileLineNumber: n };
}, nn = Ri(Oi);
nn.register("vue", function(n) {
  return {
    subLanguage: "xml",
    contains: [
      n.COMMENT("<!--", "-->", {
        relevance: 10
      }),
      {
        begin: /^(\s*)(<script>)/gm,
        end: /^(\s*)(<\/script>)/gm,
        subLanguage: "javascript",
        excludeBegin: !0,
        excludeEnd: !0
      },
      {
        begin: /^(?:\s*)(?:<script\s+lang=(["'])ts\1>)/gm,
        end: /^(\s*)(<\/script>)/gm,
        subLanguage: "typescript",
        excludeBegin: !0,
        excludeEnd: !0
      },
      {
        begin: /^(\s*)(<style(\s+scoped)?>)/gm,
        end: /^(\s*)(<\/style>)/gm,
        subLanguage: "css",
        excludeBegin: !0,
        excludeEnd: !0
      },
      {
        begin: /^(?:\s*)(?:<style(?:\s+scoped)?\s+lang=(["'])(?:s[ca]ss)\1(?:\s+scoped)?>)/gm,
        end: /^(\s*)(<\/style>)/gm,
        subLanguage: "scss",
        excludeBegin: !0,
        excludeEnd: !0
      },
      {
        begin: /^(?:\s*)(?:<style(?:\s+scoped)?\s+lang=(["'])stylus\1(?:\s+scoped)?>)/gm,
        end: /^(\s*)(<\/style>)/gm,
        subLanguage: "stylus",
        excludeBegin: !0,
        excludeEnd: !0
      }
    ]
  };
});
const Le = { name: "lowlight" };
let ni = 2e3;
const Nn = [];
Object.defineProperty(Le, "maxLineToIgnoreSyntax", {
  get: () => ni
});
Object.defineProperty(Le, "setMaxLineToIgnoreSyntax", {
  value: (e) => {
    ni = e;
  }
});
Object.defineProperty(Le, "ignoreSyntaxHighlightList", {
  get: () => Nn
});
Object.defineProperty(Le, "setIgnoreSyntaxHighlightList", {
  value: (e) => {
    Nn.length = 0, Nn.push(...e);
  }
});
Object.defineProperty(Le, "getAST", {
  value: (e, n, i) => {
    let d = !0;
    if (nn.registered(i) || (process.env.NODE_ENV === "development" && console.warn(`not support current lang: ${i} yet`), d = !1), n && ii.ignoreSyntaxHighlightList.some((l) => l instanceof RegExp ? l.test(n) : n === l)) {
      process.env.NODE_ENV === "development" && console.warn(`ignore syntax for current file, because the fileName is in the ignoreSyntaxHighlightList: ${n}`);
      return;
    }
    return d ? nn.highlight(i, e) : nn.highlightAuto(e);
  }
});
Object.defineProperty(Le, "processAST", {
  value: (e) => Qi(e)
});
Object.defineProperty(Le, "hasRegisteredCurrentLang", {
  value: (e) => nn.registered(e)
});
const ii = Le;
var Ke, an;
class Yi extends Map {
  constructor() {
    super(...arguments), Ke.set(this, []), an.set(this, 30);
  }
  setMaxLength(n) {
    I(this, an, n, "f"), this._checkLength();
  }
  set(n, i) {
    return this.has(n) ? this : (r(this, Ke, "f").push(n), this._checkLength(), super.set(n, i));
  }
  _checkLength() {
    for (; r(this, Ke, "f").length > r(this, an, "f"); ) {
      const n = r(this, Ke, "f").shift();
      this.delete(n);
    }
  }
}
Ke = /* @__PURE__ */ new WeakMap(), an = /* @__PURE__ */ new WeakMap();
var yn, ti;
const he = new Yi(), Ce = "@git-diff-cache";
he.setMaxLength(50);
he.name = "@git-diff-view/core";
process.env.NODE_ENV === "development" && typeof globalThis < "u" && (Array.isArray(globalThis[Ce]) ? (globalThis[Ce] = globalThis[Ce].filter((e) => e !== he), globalThis[Ce].length > 0 && console.warn("there are multiple instance of @git-diff-view/core in the one environment!"), globalThis[Ce].push(he)) : globalThis[Ce] = [he]);
class tn {
  static createInstance(n) {
    const i = new tn(n == null ? void 0 : n.raw, n == null ? void 0 : n.lang, n == null ? void 0 : n.fileName);
    return i.ast = n == null ? void 0 : n.ast, i.rawFile = n == null ? void 0 : n.rawFile, i.hasDoRaw = n == null ? void 0 : n.hasDoRaw, i.rawLength = n == null ? void 0 : n.rawLength, i.syntaxFile = n == null ? void 0 : n.syntaxFile, i.hasDoSyntax = n == null ? void 0 : n.hasDoSyntax, i.syntaxLength = n == null ? void 0 : n.syntaxLength, i.highlighterName = n == null ? void 0 : n.highlighterName, i.maxLineNumber = n == null ? void 0 : n.maxLineNumber, i;
  }
  constructor(n, i, d) {
    yn.add(this), this.raw = n, this.lang = i, this.fileName = d, this.rawFile = {}, this.hasDoRaw = !1, this.syntaxFile = {}, this.hasDoSyntax = !1, this.maxLineNumber = 0, Object.defineProperty(this, "__v_skip", { value: !0 });
  }
  doSyntax({ registerHighlighter: n }) {
    if (!this.raw || this.hasDoSyntax)
      return;
    const i = n || ii;
    if (this.syntaxLength) {
      process.env.NODE_ENV === "development" && console.error("current file already doSyntax before!");
      return;
    }
    if (this.rawLength > i.maxLineToIgnoreSyntax) {
      process.env.NODE_ENV === "development" && console.warn(`ignore syntax for current file, because the rawLength is too long: ${this.rawLength}`);
      return;
    }
    if (this.ast = i.getAST(this.raw, this.fileName, this.lang), !this.ast)
      return;
    const { syntaxFileObject: d, syntaxFileLineNumber: l } = i.processAST(this.ast);
    this.syntaxFile = d, this.syntaxLength = l, this.highlighterName = i.name, process.env.NODE_ENV === "development" && r(this, yn, "m", ti).call(this), this.hasDoSyntax = !0;
  }
  doRaw() {
    if (!this.raw || this.hasDoRaw)
      return;
    const i = this.raw.split(`
`);
    this.rawLength = i.length, this.maxLineNumber = i.length, this.rawFile = {};
    for (let d = 0; d < i.length; d++)
      this.rawFile[d + 1] = d < i.length - 1 ? i[d] + `
` : i[d];
    this.hasDoRaw = !0;
  }
}
yn = /* @__PURE__ */ new WeakSet(), ti = function() {
  this.rawLength && this.syntaxLength && (this.rawLength !== this.syntaxLength && console.warn("the rawLength not match for the syntaxLength"), Object.values(this.syntaxFile).forEach(({ value: n, lineNumber: i }) => {
    n !== this.rawFile[i] && console.log("some line not match:" + n + " __ " + this.rawFile[i] + " __ at: " + i + " lineNumber");
  }));
};
const De = (e, n, i) => {
  const d = e + "--0.0.12--" + n;
  if (he.has(d))
    return he.get(d);
  const l = new tn(e, n, i);
  return he.set(d, l), l;
}, et = he;
var W, P, V, ce, se, we, me, He, Ee, Se, ke, fe, re, K, j, R, B, O, ye, Ae, Me, Re, Oe, Xe, de, Je, Qe, Fe, Ye, ue, li, di, Fn, si, ai, oi, Be, Te, fn, rn;
const E = 40, _n = /* @__PURE__ */ new Set();
class cn {
  static createInstance(n, i) {
    var d, l, s, u, a, v;
    const o = new cn(((d = n == null ? void 0 : n.oldFile) === null || d === void 0 ? void 0 : d.fileName) || "", ((l = n == null ? void 0 : n.oldFile) === null || l === void 0 ? void 0 : l.content) || "", ((s = n == null ? void 0 : n.newFile) === null || s === void 0 ? void 0 : s.fileName) || "", ((u = n == null ? void 0 : n.newFile) === null || u === void 0 ? void 0 : u.content) || "", (n == null ? void 0 : n.hunks) || [], ((a = n == null ? void 0 : n.oldFile) === null || a === void 0 ? void 0 : a.fileLang) || "", ((v = n == null ? void 0 : n.newFile) === null || v === void 0 ? void 0 : v.fileLang) || "");
    return i && (i.isFullMerge ? o._mergeFullBundle(i) : o.mergeBundle(i)), o;
  }
  constructor(n, i, d, l, s, u, a) {
    W.add(this), this._oldFileName = n, this._newFileName = d, this._diffList = s, P.set(this, void 0), V.set(this, void 0), ce.set(this, void 0), se.set(this, void 0), we.set(this, void 0), me.set(this, void 0), He.set(this, void 0), Ee.set(this, void 0), Se.set(this, void 0), ke.set(this, void 0), fe.set(this, void 0), re.set(this, void 0), K.set(this, []), j.set(this, []), R.set(this, void 0), B.set(this, []), O.set(this, void 0), ye.set(this, []), Ae.set(this, !1), Me.set(this, !1), Re.set(this, !1), Oe.set(this, !1), Xe.set(this, 0), de.set(this, !1), Je.set(this, !1), Qe.set(this, !1), Fe.set(this, void 0), this._version_ = "0.0.12", this._oldFileContent = "", this._oldFileLang = "", this._newFileContent = "", this._newFileLang = "", this.diffLineLength = 0, this.splitLineLength = 0, this.unifiedLineLength = 0, this.hasExpandSplitAll = !1, this.hasExpandUnifiedAll = !1, this.hasSomeLineCollapsed = !1, Ye.set(this, ""), ue.set(this, /* @__PURE__ */ new Map()), this.getSplitLeftLine = (f) => r(this, K, "f")[f], this.getSplitRightLine = (f) => r(this, j, "f")[f], this.getSplitHunkLine = (f) => {
      var h;
      return (h = r(this, R, "f")) === null || h === void 0 ? void 0 : h[f];
    }, this.onSplitHunkExpand = (f, h, w = !0) => {
      var m, g;
      const b = (m = r(this, R, "f")) === null || m === void 0 ? void 0 : m[h];
      if (!(!b || !b.splitInfo) && !r(this, de, "f")) {
        if (f === "all") {
          for (let x = b.splitInfo.startHiddenIndex; x < b.splitInfo.endHiddenIndex; x++) {
            const _ = r(this, K, "f")[x], N = r(this, j, "f")[x];
            _ != null && _.isHidden && (_.isHidden = !1), N != null && N.isHidden && (N.isHidden = !1);
          }
          b.splitInfo = Object.assign(Object.assign(Object.assign({}, b.splitInfo), b.hunkInfo), { plainText: b.text, startHiddenIndex: b.splitInfo.endHiddenIndex });
        } else if (f === "down") {
          for (let x = b.splitInfo.startHiddenIndex; x < b.splitInfo.startHiddenIndex + E; x++) {
            const _ = r(this, K, "f")[x], N = r(this, j, "f")[x];
            _ != null && _.isHidden && (_.isHidden = !1), N != null && N.isHidden && (N.isHidden = !1);
          }
          b.isLast ? b.splitInfo = Object.assign(Object.assign({}, b.splitInfo), { startHiddenIndex: b.splitInfo.startHiddenIndex + E }) : b.splitInfo = Object.assign(Object.assign({}, b.splitInfo), { startHiddenIndex: b.splitInfo.startHiddenIndex + E, plainText: `@@ -${b.splitInfo.oldStartIndex},${b.splitInfo.oldLength} +${b.splitInfo.newStartIndex},${b.splitInfo.newLength}` });
        } else {
          if (b.isLast) {
            process.env.NODE_ENV === "development" && console.error("the last hunk can not expand up!");
            return;
          }
          for (let y = b.splitInfo.endHiddenIndex - E; y < b.splitInfo.endHiddenIndex; y++) {
            const D = r(this, K, "f")[y], k = r(this, j, "f")[y];
            D != null && D.isHidden && (D.isHidden = !1), k != null && k.isHidden && (k.isHidden = !1);
          }
          const x = b.splitInfo.oldStartIndex - E, _ = b.splitInfo.oldLength + E, N = b.splitInfo.newStartIndex - E, S = b.splitInfo.newLength + E;
          b.splitInfo = Object.assign(Object.assign({}, b.splitInfo), {
            endHiddenIndex: b.splitInfo.endHiddenIndex - E,
            oldStartIndex: x,
            oldLength: _,
            newStartIndex: N,
            newLength: S,
            plainText: `@@ -${x},${_} +${N},${S}`
          }), (g = r(this, R, "f")) === null || g === void 0 || delete g[h], r(this, R, "f")[b.splitInfo.endHiddenIndex] = b;
        }
        w && this.notifyAll();
      }
    }, this.getUnifiedLine = (f) => r(this, B, "f")[f], this.getUnifiedHunkLine = (f) => {
      var h;
      return (h = r(this, O, "f")) === null || h === void 0 ? void 0 : h[f];
    }, this.onUnifiedHunkExpand = (f, h, w = !0) => {
      var m, g, b;
      const x = (m = r(this, O, "f")) === null || m === void 0 ? void 0 : m[h];
      if (!(!x || !x.unifiedInfo) && !r(this, de, "f")) {
        if (f === "all") {
          for (let _ = x.unifiedInfo.startHiddenIndex; _ < x.unifiedInfo.endHiddenIndex; _++) {
            const N = (g = r(this, B, "f")) === null || g === void 0 ? void 0 : g[_];
            N != null && N.isHidden && (N.isHidden = !1);
          }
          x.unifiedInfo = Object.assign(Object.assign(Object.assign({}, x.unifiedInfo), x.hunkInfo), { plainText: x.text, startHiddenIndex: x.unifiedInfo.endHiddenIndex });
        } else if (f === "down") {
          for (let _ = x.unifiedInfo.startHiddenIndex; _ < x.unifiedInfo.startHiddenIndex + E; _++) {
            const N = r(this, B, "f")[_];
            N != null && N.isHidden && (N.isHidden = !1);
          }
          x.isLast ? x.unifiedInfo = Object.assign(Object.assign({}, x.unifiedInfo), { startHiddenIndex: x.unifiedInfo.startHiddenIndex + E }) : x.unifiedInfo = Object.assign(Object.assign({}, x.unifiedInfo), { startHiddenIndex: x.unifiedInfo.startHiddenIndex + E, plainText: `@@ -${x.unifiedInfo.oldStartIndex},${x.unifiedInfo.oldLength} +${x.unifiedInfo.newStartIndex},${x.unifiedInfo.newLength}` });
        } else {
          if (x.isLast) {
            process.env.NODE_ENV === "development" && console.error("the last hunk can not expand up!");
            return;
          }
          for (let D = x.unifiedInfo.endHiddenIndex - E; D < x.unifiedInfo.endHiddenIndex; D++) {
            const k = r(this, B, "f")[D];
            k != null && k.isHidden && (k.isHidden = !1);
          }
          const _ = x.unifiedInfo.oldStartIndex - E, N = x.unifiedInfo.oldLength + E, S = x.unifiedInfo.newStartIndex - E, y = x.unifiedInfo.newLength + E;
          x.unifiedInfo = Object.assign(Object.assign({}, x.unifiedInfo), {
            endHiddenIndex: x.unifiedInfo.endHiddenIndex - E,
            oldStartIndex: _,
            oldLength: N,
            newStartIndex: S,
            newLength: y,
            plainText: `@@ -${_},${N} +${S},${y}`
          }), (b = r(this, O, "f")) === null || b === void 0 || delete b[h], r(this, O, "f")[x.unifiedInfo.endHiddenIndex] = x;
        }
        w && this.notifyAll();
      }
    }, this.onAllExpand = (f) => {
      r(this, de, "f") || (f === "split" ? (Object.keys(r(this, R, "f") || {}).forEach((h) => {
        this.onSplitHunkExpand("all", +h, !1);
      }), this.hasExpandSplitAll = !0) : (Object.keys(r(this, O, "f") || {}).forEach((h) => {
        this.onUnifiedHunkExpand("all", +h, !1);
      }), this.hasExpandUnifiedAll = !0), this.notifyAll());
    }, this.onAllCollapse = (f) => {
      r(this, de, "f") || (f === "split" ? (Object.values(r(this, K, "f") || {}).forEach((h) => {
        !h.isHidden && h._isHidden && (h.isHidden = h._isHidden);
      }), Object.values(r(this, j, "f") || {}).forEach((h) => {
        !h.isHidden && h._isHidden && (h.isHidden = h._isHidden);
      }), Object.values(r(this, R, "f") || {}).forEach((h) => {
        h.splitInfo && (h.splitInfo = Object.assign(Object.assign({}, h.splitInfo), { oldStartIndex: h.splitInfo._oldStartIndex, oldLength: h.splitInfo._oldLength, newStartIndex: h.splitInfo._newStartIndex, newLength: h.splitInfo._newLength, startHiddenIndex: h.splitInfo._startHiddenIndex, endHiddenIndex: h.splitInfo._endHiddenIndex, plainText: h.splitInfo._plainText }));
      }), Object.keys(r(this, R, "f") || {}).forEach((h) => {
        const w = r(this, R, "f")[h];
        w.splitInfo && w.splitInfo.endHiddenIndex !== +h && (delete r(this, R, "f")[h], r(this, R, "f")[w.splitInfo.endHiddenIndex] = w);
      }), this.hasExpandSplitAll = !1) : (Object.values(r(this, B, "f") || {}).forEach((h) => {
        !h.isHidden && h._isHidden && (h.isHidden = h._isHidden);
      }), Object.values(r(this, O, "f") || {}).forEach((h) => {
        h.unifiedInfo && (h.unifiedInfo = Object.assign(Object.assign({}, h.unifiedInfo), { oldStartIndex: h.unifiedInfo._oldStartIndex, oldLength: h.unifiedInfo._oldLength, newStartIndex: h.unifiedInfo._newStartIndex, newLength: h.unifiedInfo._newLength, startHiddenIndex: h.unifiedInfo._startHiddenIndex, endHiddenIndex: h.unifiedInfo._endHiddenIndex, plainText: h.unifiedInfo._plainText }));
      }), Object.keys(r(this, O, "f") || {}).forEach((h) => {
        const w = r(this, O, "f")[h];
        w.unifiedInfo && w.unifiedInfo.endHiddenIndex !== +h && (delete r(this, O, "f")[h], r(this, O, "f")[w.unifiedInfo.endHiddenIndex] = w);
      }), this.hasExpandUnifiedAll = !1), this.notifyAll());
    }, this.getOldSyntaxLine = (f) => {
      var h;
      return (h = r(this, Se, "f")) === null || h === void 0 ? void 0 : h[f];
    }, this.getNewSyntaxLine = (f) => {
      var h;
      return (h = r(this, ke, "f")) === null || h === void 0 ? void 0 : h[f];
    }, this.subscribe = (f) => (r(this, ye, "f").push(f), () => {
      r(this, ye, "f").filter((h) => h !== f);
    }), this.notifyAll = (f) => {
      var h;
      I(this, Xe, (h = r(this, Xe, "f"), h++, h), "f"), r(this, ye, "f").forEach((w) => {
        f && w.isSyncExternal || w();
      }), r(this, ue, "f").forEach((w, m) => {
        m.notifyAll(!0);
      });
    }, this.getUpdateCount = () => r(this, Xe, "f"), this.getExpandEnabled = () => !r(this, de, "f"), this.getBundle = () => {
      const f = r(this, Ae, "f"), h = r(this, Me, "f"), w = r(this, Re, "f"), m = r(this, Oe, "f"), g = r(this, He, "f"), b = r(this, we, "f"), x = r(this, Se, "f"), _ = r(this, fe, "f"), N = r(this, Ee, "f"), S = r(this, me, "f"), y = r(this, ke, "f"), D = r(this, re, "f"), k = this.splitLineLength, H = this.unifiedLineLength, G = r(this, de, "f"), z = r(this, Fe, "f"), q = this.hasSomeLineCollapsed, ne = r(this, K, "f"), ie = r(this, j, "f"), pe = r(this, R, "f"), _e = r(this, B, "f"), Ie = r(this, O, "f"), Ne = this._version_;
      return {
        hasInitRaw: f,
        hasInitSyntax: h,
        hasBuildSplit: w,
        hasBuildUnified: m,
        oldFileLines: g,
        oldFileDiffLines: b,
        oldFileSyntaxLines: x,
        oldFilePlaceholderLines: _,
        newFileLines: N,
        newFileDiffLines: S,
        newFileSyntaxLines: y,
        newFilePlaceholderLines: D,
        splitLineLength: k,
        unifiedLineLength: H,
        splitLeftLines: ne,
        splitRightLines: ie,
        splitHunkLines: pe,
        unifiedLines: _e,
        unifiedHunkLines: Ie,
        highlighterName: z,
        composeByDiff: G,
        hasSomeLineCollapsed: q,
        version: Ne,
        isFullMerge: !1
      };
    }, this.mergeBundle = (f) => {
      I(this, Ae, f.hasInitRaw, "f"), I(this, Me, f.hasInitSyntax, "f"), I(this, Re, f.hasBuildSplit, "f"), I(this, Oe, f.hasBuildUnified, "f"), I(this, de, f.composeByDiff, "f"), I(this, Fe, f.highlighterName, "f"), I(this, He, f.oldFileLines, "f"), I(this, we, f.oldFileDiffLines, "f"), I(this, Se, f.oldFileSyntaxLines, "f"), I(this, fe, f.oldFilePlaceholderLines, "f"), I(this, Ee, f.newFileLines, "f"), I(this, me, f.newFileDiffLines, "f"), I(this, ke, f.newFileSyntaxLines, "f"), I(this, re, f.newFilePlaceholderLines, "f"), this.splitLineLength = f.splitLineLength, this.unifiedLineLength = f.unifiedLineLength, this.hasSomeLineCollapsed = f.hasSomeLineCollapsed, I(this, K, f.splitLeftLines, "f"), I(this, j, f.splitRightLines, "f"), I(this, R, f.splitHunkLines, "f"), I(this, B, f.unifiedLines, "f"), I(this, O, f.unifiedHunkLines, "f"), I(this, Je, !0, "f"), process.env.NODE_ENV === "development" && this._version_ !== f.version && console.error("the version of the `diffInstance` is not match, some error may happen!"), this.notifyAll();
    }, this._getHighlighterName = () => r(this, Fe, "f"), this._getIsPureDiffRender = () => r(this, de, "f"), this._addClonedInstance = (f) => {
      const h = () => {
        this._notifyOthers(f);
      };
      h.isSyncExternal = !0;
      const w = f.subscribe(h);
      r(this, ue, "f").set(f, w);
    }, this._notifyOthers = (f) => {
      r(this, ue, "f").forEach((h, w) => {
        w !== f && w.notifyAll(!0);
      });
    }, this._delClonedInstance = (f) => {
      const h = r(this, ue, "f").get(f);
      h && h(), r(this, ue, "f").delete(f);
    }, this._getFullBundle = () => {
      const f = this.getBundle(), h = r(this, P, "f"), w = r(this, V, "f"), m = r(this, se, "f"), g = r(this, ce, "f");
      return Object.assign(Object.assign({}, f), {
        oldFileResult: h,
        newFileResult: w,
        diffLines: m,
        diffListResults: g,
        // get current instance is a fullMerge instance or not
        isFullMerge: r(this, Je, "f") ? r(this, Qe, "f") : !0
      });
    }, this._mergeFullBundle = (f) => {
      this.mergeBundle(f);
      try {
        I(this, P, tn.createInstance(f.oldFileResult), "f"), I(this, V, tn.createInstance(f.newFileResult), "f"), I(this, se, f.diffLines, "f"), I(this, ce, f.diffListResults, "f"), I(this, Qe, f.isFullMerge, "f");
      } catch {
      }
    }, this._destroy = () => {
      this.clearId(), r(this, ye, "f").splice(0, r(this, ye, "f").length), r(this, ue, "f").forEach((f) => f()), r(this, ue, "f").clear();
    }, this.clear = () => {
      this._destroy(), I(this, P, null, "f"), I(this, V, null, "f"), I(this, se, null, "f"), I(this, ce, null, "f"), I(this, me, null, "f"), I(this, we, null, "f"), I(this, Ee, null, "f"), I(this, He, null, "f"), I(this, ke, null, "f"), I(this, Se, null, "f"), I(this, R, null, "f"), I(this, K, null, "f"), I(this, j, null, "f"), I(this, O, null, "f"), I(this, B, null, "f");
    }, Object.defineProperty(this, "__v_skip", { value: !0 });
    let v = i, o = l;
    const c = Array.from(new Set(s));
    Object.defineProperties(this, {
      _oldFileName: { get: () => n },
      _newFileName: { get: () => d },
      _oldFileLang: { get: () => Un(u || n || a || d) || "txt" },
      _newFileLang: { get: () => Un(a || d || u || n) || "txt" },
      _oldFileContent: {
        get: () => v,
        set: (f) => v = f
      },
      _newFileContent: {
        get: () => o,
        set: (f) => o = f
      },
      _diffList: { get: () => c }
    }), this.initId();
  }
  initId() {
    let n = "--" + Math.random().toString().slice(2);
    for (; _n.has(n); )
      n = "--" + Math.random().toString().slice(2);
    _n.add(n), I(this, Ye, n, "f");
  }
  getId() {
    return r(this, Ye, "f");
  }
  clearId() {
    _n.delete(r(this, Ye, "f"));
  }
  initRaw() {
    r(this, Ae, "f") || (r(this, W, "m", li).call(this), r(this, W, "m", ai).call(this), r(this, W, "m", di).call(this), r(this, W, "m", Fn).call(this), r(this, W, "m", si).call(this), I(this, Ae, !0, "f"));
  }
  initSyntax({ registerHighlighter: n } = {}) {
    var i, d;
    if (!r(this, Me, "f")) {
      if (r(this, Je, "f") && !r(this, Qe, "f")) {
        process.env.NODE_ENV === "development" && console.error("this instance can not do syntax because of the data missing, try to use '_getFullBundle' & '_mergeFullBundle' instead of 'getBundle' & 'mergeBundle'");
        return;
      }
      r(this, W, "m", oi).call(this, { registerHighlighter: n }), I(this, Fe, ((i = r(this, P, "f")) === null || i === void 0 ? void 0 : i.highlighterName) || ((d = r(this, V, "f")) === null || d === void 0 ? void 0 : d.highlighterName) || r(this, Fe, "f"), "f"), I(this, Me, !0, "f");
    }
  }
  init() {
    this.initRaw(), this.initSyntax();
  }
  buildSplitDiffLines() {
    var n, i, d, l, s, u, a;
    if (r(this, Re, "f"))
      return;
    let v = 1, o = 1, c = !1, f = 1 / 0;
    const h = ((n = r(this, P, "f")) === null || n === void 0 ? void 0 : n.maxLineNumber) || 0, w = ((i = r(this, V, "f")) === null || i === void 0 ? void 0 : i.maxLineNumber) || 0;
    for (; v <= h || o <= w; ) {
      const m = r(this, W, "m", Be).call(this, v), g = r(this, W, "m", Te).call(this, o), b = r(this, W, "m", fn).call(this, v), x = r(this, W, "m", rn).call(this, o), _ = m == null ? void 0 : m.isIncludeableLine(), N = g == null ? void 0 : g.isIncludeableLine(), S = r(this, j, "f").length, y = !m && !g;
      if (m && !g) {
        if (m.newLineNumber && m.newLineNumber > o) {
          o++;
          continue;
        }
        (m.newLineNumber === null || m.newLineNumber === void 0) && o++;
      }
      if (g && !m) {
        if (g.oldLineNumber && g.oldLineNumber > v) {
          v++;
          continue;
        }
        (g.oldLineNumber === null || g.oldLineNumber === void 0) && v++;
      }
      if (!m && !b && !g && !x)
        break;
      if (!m && !g) {
        if (!((d = r(this, fe, "f")) === null || d === void 0) && d[v] && (!((l = r(this, re, "f")) === null || l === void 0) && l[o])) {
          v++, o++;
          continue;
        }
        if (!b && (!((s = r(this, re, "f")) === null || s === void 0) && s[o])) {
          o++;
          continue;
        }
        if (!x && (!((u = r(this, fe, "f")) === null || u === void 0) && u[v])) {
          v++;
          continue;
        }
      }
      if (_ && N || !_ && !N ? (r(this, K, "f").push({
        lineNumber: v++,
        value: b,
        diff: m,
        isHidden: y,
        _isHidden: y
      }), r(this, j, "f").push({
        lineNumber: o++,
        value: x,
        diff: g,
        isHidden: y,
        _isHidden: y
      })) : _ ? (r(this, K, "f").push({
        lineNumber: v++,
        value: b,
        diff: m,
        isHidden: y,
        _isHidden: y
      }), r(this, j, "f").push({})) : N && (r(this, K, "f").push({}), r(this, j, "f").push({
        lineNumber: o++,
        value: x,
        diff: g,
        isHidden: y,
        _isHidden: y
      })), !c && y && (f = S), y && (this.hasSomeLineCollapsed = !0), c = y, m && g && !_ && !N) {
        const D = g, k = g.index ? (a = r(this, se, "f")) === null || a === void 0 ? void 0 : a[D.index - 1] : void 0;
        if (k && k.type === C.Hunk) {
          const H = k;
          Number.isFinite(f) && (H.splitInfo = Object.assign(Object.assign({}, H.hunkInfo), { startHiddenIndex: f, endHiddenIndex: S, plainText: H.text, _startHiddenIndex: f, _endHiddenIndex: S, _plainText: H.text }), f = 1 / 0), I(this, R, Object.assign(Object.assign({}, r(this, R, "f")), { [S]: H }), "f");
        }
      }
    }
    if (Number.isFinite(f)) {
      const g = new ve("", C.Hunk, null, null, null);
      g.isLast = !0, g.splitInfo = {
        startHiddenIndex: f,
        endHiddenIndex: r(this, j, "f").length,
        _startHiddenIndex: f,
        _endHiddenIndex: r(this, j, "f").length,
        // just for placeholder
        plainText: "",
        oldStartIndex: 0,
        newStartIndex: 0,
        oldLength: 0,
        newLength: 0,
        _plainText: "",
        _oldStartIndex: 0,
        _newStartIndex: 0,
        _oldLength: 0,
        _newLength: 0
      }, I(this, R, Object.assign(Object.assign({}, r(this, R, "f")), { [r(this, j, "f").length]: g }), "f"), f = 1 / 0;
    }
    this.splitLineLength = r(this, j, "f").length, I(this, Re, !0, "f"), this.notifyAll();
  }
  buildUnifiedDiffLines() {
    var n, i, d, l, s, u, a;
    if (r(this, Oe, "f"))
      return;
    let v = 1, o = 1, c = !1, f = 1 / 0;
    const h = ((n = r(this, P, "f")) === null || n === void 0 ? void 0 : n.maxLineNumber) || 0, w = ((i = r(this, V, "f")) === null || i === void 0 ? void 0 : i.maxLineNumber) || 0;
    for (; v <= h || o <= w; ) {
      const m = r(this, W, "m", fn).call(this, v), g = r(this, W, "m", Be).call(this, v), b = r(this, W, "m", rn).call(this, o), x = r(this, W, "m", Te).call(this, o), _ = g == null ? void 0 : g.isIncludeableLine(), N = x == null ? void 0 : x.isIncludeableLine(), S = r(this, B, "f").length, y = !g && !x;
      if (g && !x) {
        if (g.newLineNumber && g.newLineNumber > o) {
          o++;
          continue;
        }
        (g.newLineNumber === null || g.newLineNumber === void 0) && o++;
      }
      if (x && !g) {
        if (x.oldLineNumber && x.oldLineNumber > v) {
          v++;
          continue;
        }
        (x.oldLineNumber === null || x.oldLineNumber === void 0) && v++;
      }
      if (!m && !b && !x && !g)
        break;
      if (!g && !x) {
        if (!((d = r(this, fe, "f")) === null || d === void 0) && d[v] && (!((l = r(this, re, "f")) === null || l === void 0) && l[o])) {
          v++, o++;
          continue;
        }
        if (!m && (!((s = r(this, re, "f")) === null || s === void 0) && s[o])) {
          o++;
          continue;
        }
        if (!b && (!((u = r(this, fe, "f")) === null || u === void 0) && u[v])) {
          v++;
          continue;
        }
      }
      if (!_ && !N ? r(this, B, "f").push({
        oldLineNumber: v++,
        newLineNumber: o++,
        value: b,
        diff: x,
        isHidden: y,
        _isHidden: y
      }) : _ ? r(this, B, "f").push({
        oldLineNumber: v++,
        value: m,
        diff: g,
        isHidden: y,
        _isHidden: y
      }) : N && r(this, B, "f").push({
        newLineNumber: o++,
        value: b,
        diff: x,
        isHidden: y,
        _isHidden: y
      }), !c && y && (f = S), y && (this.hasSomeLineCollapsed = !0), c = y, g && x && !_ && !N) {
        const D = x, k = D.index ? (a = r(this, se, "f")) === null || a === void 0 ? void 0 : a[D.index - 1] : void 0;
        if (k && k.type === C.Hunk) {
          const H = k;
          Number.isFinite(f) && (H.unifiedInfo = Object.assign(Object.assign({}, H.hunkInfo), { startHiddenIndex: f, endHiddenIndex: S, plainText: H.text, _startHiddenIndex: f, _endHiddenIndex: S, _plainText: H.text }), f = 1 / 0), I(this, O, Object.assign(Object.assign({}, r(this, O, "f")), { [S]: H }), "f");
        }
      }
    }
    if (Number.isFinite(f)) {
      const g = new ve("", C.Hunk, null, null, null);
      g.isLast = !0, g.unifiedInfo = {
        startHiddenIndex: f,
        endHiddenIndex: r(this, B, "f").length,
        _startHiddenIndex: f,
        _endHiddenIndex: r(this, B, "f").length,
        // just for placeholder
        plainText: "",
        oldStartIndex: 0,
        newStartIndex: 0,
        oldLength: 0,
        newLength: 0,
        _plainText: "",
        _oldStartIndex: 0,
        _newStartIndex: 0,
        _oldLength: 0,
        _newLength: 0
      }, I(this, O, Object.assign(Object.assign({}, r(this, O, "f")), { [r(this, B, "f").length]: g }), "f"), f = 1 / 0;
    }
    this.unifiedLineLength = r(this, B, "f").length, I(this, Oe, !0, "f"), this.notifyAll();
  }
}
P = /* @__PURE__ */ new WeakMap(), V = /* @__PURE__ */ new WeakMap(), ce = /* @__PURE__ */ new WeakMap(), se = /* @__PURE__ */ new WeakMap(), we = /* @__PURE__ */ new WeakMap(), me = /* @__PURE__ */ new WeakMap(), He = /* @__PURE__ */ new WeakMap(), Ee = /* @__PURE__ */ new WeakMap(), Se = /* @__PURE__ */ new WeakMap(), ke = /* @__PURE__ */ new WeakMap(), fe = /* @__PURE__ */ new WeakMap(), re = /* @__PURE__ */ new WeakMap(), K = /* @__PURE__ */ new WeakMap(), j = /* @__PURE__ */ new WeakMap(), R = /* @__PURE__ */ new WeakMap(), B = /* @__PURE__ */ new WeakMap(), O = /* @__PURE__ */ new WeakMap(), ye = /* @__PURE__ */ new WeakMap(), Ae = /* @__PURE__ */ new WeakMap(), Me = /* @__PURE__ */ new WeakMap(), Re = /* @__PURE__ */ new WeakMap(), Oe = /* @__PURE__ */ new WeakMap(), Xe = /* @__PURE__ */ new WeakMap(), de = /* @__PURE__ */ new WeakMap(), Je = /* @__PURE__ */ new WeakMap(), Qe = /* @__PURE__ */ new WeakMap(), Fe = /* @__PURE__ */ new WeakMap(), Ye = /* @__PURE__ */ new WeakMap(), ue = /* @__PURE__ */ new WeakMap(), W = /* @__PURE__ */ new WeakSet(), li = function() {
  this._diffList && I(this, ce, this._diffList.map((n) => Ji.parse(n)), "f");
}, di = function() {
  !this._oldFileContent && !this._newFileContent || (this._oldFileContent && I(this, P, De(this._oldFileContent, this._oldFileLang, this._oldFileName), "f"), this._newFileContent && I(this, V, De(this._newFileContent, this._newFileLang, this._newFileName), "f"));
}, Fn = function() {
  var n, i, d, l;
  (n = r(this, P, "f")) === null || n === void 0 || n.doRaw(), I(this, He, (i = r(this, P, "f")) === null || i === void 0 ? void 0 : i.rawFile, "f"), (d = r(this, V, "f")) === null || d === void 0 || d.doRaw(), I(this, Ee, (l = r(this, V, "f")) === null || l === void 0 ? void 0 : l.rawFile, "f");
}, si = function() {
  if (this._oldFileContent && this._newFileContent)
    return;
  const n = {}, i = {};
  if (!this._oldFileContent && !this._newFileContent) {
    let d = 1, l = 1, s = "", u = "", a = !1;
    for (; l <= this.diffLineLength || d <= this.diffLineLength; ) {
      const v = l++, o = d++, c = r(this, W, "m", Be).call(this, v), f = r(this, W, "m", Te).call(this, o);
      c ? s += c.text : (s += `
`, n[v] = !0), f ? u += f.text : (u += `
`, i[o] = !0), !a && c && f && (a = a || c.noTrailingNewLine !== f.noTrailingNewLine);
    }
    if (!a && s === u)
      return;
    this._oldFileContent = s, this._newFileContent = u, I(this, P, De(this._oldFileContent, this._oldFileLang, this._oldFileName), "f"), I(this, V, De(this._newFileContent, this._newFileLang, this._newFileName), "f"), I(this, fe, n, "f"), I(this, re, i, "f"), I(this, de, !0, "f");
  } else if (r(this, P, "f")) {
    let d = 1, l = 1, s = "", u = !1;
    for (; l <= r(this, P, "f").maxLineNumber; ) {
      const a = r(this, W, "m", Te).call(this, d++), v = r(this, W, "m", Be).call(this, l);
      a ? (s += a.text, l = a.oldLineNumber ? a.oldLineNumber + 1 : l) : (v || (s += r(this, W, "m", fn).call(this, l)), l++), !u && a && v && (u = u || a.noTrailingNewLine !== v.noTrailingNewLine);
    }
    if (!u && s === this._oldFileContent)
      return;
    this._newFileContent = s, I(this, V, De(this._newFileContent, this._newFileLang, this._newFileName), "f");
  } else if (r(this, V, "f")) {
    let d = 1, l = 1, s = "", u = !1;
    for (; l <= r(this, V, "f").maxLineNumber; ) {
      const a = r(this, W, "m", Be).call(this, d++), v = r(this, W, "m", Te).call(this, l);
      a ? (s += a.text, l = a.newLineNumber ? a.newLineNumber + 1 : l) : (v || (s += r(this, W, "m", rn).call(this, l)), l++), !u && v && a && (u = u || v.noTrailingNewLine !== a.noTrailingNewLine);
    }
    if (!u && s === this._newFileContent)
      return;
    this._oldFileContent = s, I(this, P, De(this._oldFileContent, this._oldFileLang, this._oldFileName), "f");
  }
  r(this, W, "m", Fn).call(this);
}, ai = function() {
  var n;
  if (!(!((n = r(this, ce, "f")) === null || n === void 0) && n.length))
    return;
  r(this, ce, "f").forEach((d) => {
    d.hunks.forEach((s) => {
      let u = [], a = [];
      s.lines.forEach((v) => {
        v.type === C.Add ? u.push(v) : v.type === C.Delete ? a.push(v) : (Pn(u, a), u = [], a = []);
      }), Pn(u, a);
    });
  }), I(this, se, [], "f");
  const i = [];
  r(this, ce, "f").forEach((d) => {
    d.hunks.forEach((l) => {
      i.push(...l.lines);
    });
  }), I(this, se, i.map((d, l) => {
    var s;
    const u = d;
    if (u.index = l, u.type === C.Hunk) {
      const a = (s = u.text.split("@@")) === null || s === void 0 ? void 0 : s[1].split(" ").filter(Boolean), v = (a == null ? void 0 : a[0]) || "", o = (a == null ? void 0 : a[1]) || "", [c, f] = v.split(","), [h, w] = o.split(","), m = u;
      m.hunkInfo = {
        oldStartIndex: -Number(c),
        oldLength: Number(f),
        newStartIndex: +Number(h),
        newLength: Number(w),
        _oldStartIndex: -Number(c),
        _oldLength: Number(f),
        _newStartIndex: +Number(h),
        _newLength: Number(w)
      };
    }
    return u;
  }), "f"), I(this, we, {}, "f"), r(this, se, "f").forEach((d) => {
    d.oldLineNumber && (this.diffLineLength = Math.max(this.diffLineLength, d.oldLineNumber), r(this, we, "f")[d.oldLineNumber] = d);
  }), I(this, me, {}, "f"), r(this, se, "f").forEach((d) => {
    d.newLineNumber && (this.diffLineLength = Math.max(this.diffLineLength, d.newLineNumber), r(this, me, "f")[d.newLineNumber] = d);
  });
}, oi = function({ registerHighlighter: n }) {
  var i, d, l, s;
  (i = r(this, P, "f")) === null || i === void 0 || i.doSyntax({ registerHighlighter: n }), I(this, Se, (d = r(this, P, "f")) === null || d === void 0 ? void 0 : d.syntaxFile, "f"), (l = r(this, V, "f")) === null || l === void 0 || l.doSyntax({ registerHighlighter: n }), I(this, ke, (s = r(this, V, "f")) === null || s === void 0 ? void 0 : s.syntaxFile, "f");
}, Be = function(n) {
  var i;
  if (n)
    return (i = r(this, we, "f")) === null || i === void 0 ? void 0 : i[n];
}, Te = function(n) {
  var i;
  if (n)
    return (i = r(this, me, "f")) === null || i === void 0 ? void 0 : i[n];
}, fn = function(n) {
  var i;
  return (i = r(this, He, "f")) === null || i === void 0 ? void 0 : i[n];
}, rn = function(n) {
  var i;
  return (i = r(this, Ee, "f")) === null || i === void 0 ? void 0 : i[n];
};
var Z;
(function(e) {
  e[e.hunk = 1] = "hunk", e[e.content = 2] = "content", e[e.widget = 3] = "widget", e[e.extend = 4] = "extend";
})(Z || (Z = {}));
const nt = (e, n) => {
  const i = e.splitLineLength, d = [];
  return Xn(i, (l) => {
    var s, u;
    const a = e.getSplitHunkLine(l), v = e.getSplitLeftLine(l), o = e.getSplitRightLine(l), c = (n == null ? void 0 : n.hasRenderWidget) && ((s = n.widgetData) === null || s === void 0 ? void 0 : s[l + 1]), f = (n == null ? void 0 : n.hasRenderExtend) && ((u = n.extendData) === null || u === void 0 ? void 0 : u[l + 1]);
    a && a.splitInfo && a.splitInfo.startHiddenIndex < a.splitInfo.endHiddenIndex && d.push({ type: Z.hunk, index: l, lineNumber: l + 1, hunkLine: a }), a && !a.splitInfo && !a.unifiedInfo && a.type === C.Hunk && d.push({ type: Z.hunk, index: l, lineNumber: l + 1, hunkLine: a }), !(v != null && v.isHidden) && !(o != null && o.isHidden) && d.push({
      type: Z.content,
      index: l,
      lineNumber: l + 1,
      splitLine: { left: v, right: o }
    }), c && d.push({ type: Z.widget, index: l, lineNumber: l + 1, widgetLine: c }), f && d.push({ type: Z.extend, index: l, lineNumber: l + 1, extendLine: f });
  }), d;
}, vn = (e) => nt(e, {}).filter((i) => i.type === Z.content), it = (e, n) => {
  const i = e.unifiedLineLength, d = [];
  return Xn(i, (l) => {
    var s, u;
    const a = e.getUnifiedHunkLine(l), v = e.getUnifiedLine(l), o = (n == null ? void 0 : n.hasRenderWidget) && ((s = n.widgetData) === null || s === void 0 ? void 0 : s[l + 1]), c = (n == null ? void 0 : n.hasRenderExtend) && ((u = n.extendData) === null || u === void 0 ? void 0 : u[l + 1]);
    a && a.unifiedInfo && a.unifiedInfo.startHiddenIndex < a.unifiedInfo.endHiddenIndex && d.push({ type: Z.hunk, index: l, lineNumber: l + 1, hunkLine: a }), a && !a.splitInfo && !a.unifiedInfo && a.type === C.Hunk && d.push({ type: Z.hunk, index: l, lineNumber: l + 1, hunkLine: a }), !v.isHidden && d.push({ type: Z.content, index: l, lineNumber: l + 1, unifiedLine: v }), o && d.push({ type: Z.widget, index: l, lineNumber: l + 1, widgetLine: o }), c && d.push({ type: Z.extend, index: l, lineNumber: l + 1, extendLine: c });
  }), d;
}, Vn = (e) => it(e, {}).filter((i) => i.type === Z.content), Ct = "0.0.12", ui = Symbol(), fi = Symbol(), ri = Symbol(), ci = Symbol(), vi = Symbol(), hi = Symbol(), gi = Symbol(), xi = Symbol(), bi = Symbol(), wi = Symbol(), mi = Symbol(), Li = () => ae(ui), pi = () => ae(fi), En = () => ae(ri), Cn = () => ae(ci), Dn = () => ae(vi), $n = () => ae(hi), Wn = () => ae(xi), An = () => ae(bi), ze = () => ae(gi), Mn = () => ae(wi), Ze = () => ae(mi), ln = () => {
  const e = L(!1);
  return Ai(() => {
    e.value = !0;
  }), e;
}, $e = (e, n, i, d) => {
  const l = L((e == null ? void 0 : e[n]) || (d == null ? void 0 : d.defaultValue));
  sn(() => e == null ? void 0 : e[n], () => {
    l.value = e[n];
  }, { deep: d == null ? void 0 : d.deepWatch }), We(i, l);
}, U = (e, n) => {
  qe((d) => {
    const l = e.diffFile;
    n(l);
    const s = l.subscribe(() => n(l));
    d(s);
  });
};
function dn(e, n, i, d) {
  if (i === "a" && !d)
    throw new TypeError("Private accessor was defined without a getter");
  if (typeof n == "function" ? e !== n || !d : !n.has(e))
    throw new TypeError("Cannot read private member from an object whose class did not declare it");
  return i === "m" ? d : i === "a" ? d.call(e) : d ? d.value : n.get(e);
}
function tt(e, n, i, d, l) {
  if (d === "m")
    throw new TypeError("Private method is not writable");
  if (d === "a" && !l)
    throw new TypeError("Private accessor was defined without a setter");
  if (typeof n == "function" ? e !== n || !l : !n.has(e))
    throw new TypeError("Cannot write private member to an object whose class did not declare it");
  return d === "a" ? l.call(e, i) : l ? l.value = i : n.set(e, i), i;
}
var Sn, on, un, _i;
let In = null;
class lt {
  constructor() {
    Sn.add(this), on.set(this, ""), un.set(this, {});
  }
  measure(n, i) {
    const d = `${i == null ? void 0 : i.fontFamily}-${i == null ? void 0 : i.fontStyle}-${i == null ? void 0 : i.fontSize}-${n}`;
    if (dn(this, un, "f")[d])
      return dn(this, un, "f")[d];
    const l = dn(this, Sn, "m", _i).call(this);
    if (i) {
      const u = `${i.fontFamily}-${i.fontStyle}-${i.fontSize}`;
      dn(this, on, "f") !== u && (tt(this, on, u, "f"), l.font = `${i.fontStyle || ""} ${i.fontSize || ""} ${i.fontFamily || ""}`);
    } else
      l.font = "";
    return l.measureText(n).width;
  }
}
on = /* @__PURE__ */ new WeakMap(), un = /* @__PURE__ */ new WeakMap(), Sn = /* @__PURE__ */ new WeakSet(), _i = function() {
  return In = In || document.createElement("canvas").getContext("2d"), In;
};
const dt = new lt(), Rn = ({ text: e, font: n }) => {
  const i = ln(), d = L(0);
  return xn(() => {
    i.value && (d.value = dt.measure(e.value || "", n.value));
  }), d;
}, bn = ({ selector: e, enable: n }) => {
  const i = Li(), d = ln(), l = L(0), s = (u) => {
    if (d.value && n.value) {
      const a = document.querySelector(`#diff-root${i.value}`), v = a == null ? void 0 : a.querySelector(e.value);
      if (!v)
        return;
      const o = v, c = () => {
        var w;
        const m = v == null ? void 0 : v.getBoundingClientRect();
        l.value = (w = m == null ? void 0 : m.width) !== null && w !== void 0 ? w : 0;
      };
      c();
      const f = () => {
        var w;
        o.__observeCallback.delete(c), o.__observeCallback.size === 0 && ((w = o.__observeInstance) === null || w === void 0 || w.disconnect(), o.removeAttribute("data-observe"), delete o.__observeCallback, delete o.__observeInstance);
      };
      if (o.__observeCallback) {
        o.__observeCallback.add(c), u(() => f());
        return;
      }
      o.__observeCallback = /* @__PURE__ */ new Set(), o.__observeCallback.add(c);
      const h = new ResizeObserver(() => o.__observeCallback.forEach((w) => w()));
      o.__observeInstance = h, h.observe(o), o.setAttribute("data-observe", "height"), u(() => f());
    }
  };
  return xn((u) => s(u)), l;
}, wn = ({ selector: e, side: n, enable: i }) => {
  const d = Li(), l = ln();
  xn((u) => {
    if (l.value && i.value) {
      const a = document.querySelector(`#diff-root${d.value}`), v = Array.from(a == null ? void 0 : a.querySelectorAll(e.value));
      if (v.length === 2) {
        const o = v[0], c = v[1], f = () => {
          o.style.height = "auto", c.style.height = "auto";
          const m = o.getBoundingClientRect(), g = c.getBoundingClientRect();
          if (m.height !== g.height) {
            const b = Math.max(m.height, g.height);
            o.style.height = b + "px", c.style.height = b + "px", o.setAttribute("data-sync-height", String(b)), c.setAttribute("data-sync-height", String(b));
          } else
            o.removeAttribute("data-sync-height"), c.removeAttribute("data-sync-height");
        }, h = new ResizeObserver(f);
        f();
        const w = o.getAttribute("data-side") === n.value ? o : c;
        h.observe(w), u(() => h.disconnect());
      }
    }
  });
}, Ii = "--diff-add-content--", Ni = "--diff-del-content--", yi = "--diff-add-lineNumber--", Fi = "--diff-del-lineNumber--", Si = "--diff-plain-content--", hn = "--diff-expand-content--", ee = "--diff-plain-lineNumber-color--", ki = "--diff-plain-lineNumber--", ge = "--diff-hunk-content--", Ue = "--diff-hunk-content-color--", Pe = "--diff-hunk-lineNumber--", Hi = "--diff-add-content-highlight--", Ei = "--diff-del-content-highlight--", Ci = "--diff-add-widget--", Di = "--diff-add-widget-color--", xe = "--diff-empty-content--", kn = (e, n, i) => e ? `var(${Ii})` : n ? `var(${Ni})` : i ? `var(${Si})` : `var(${hn})`, Hn = (e, n, i) => e ? `var(${yi})` : n ? `var(${Fi})` : i ? `var(${ki})` : `var(${hn})`, st = /* @__PURE__ */ M((e) => {
  var n, i, d, l, s;
  const u = Wn(), a = ze(), v = F(() => p[e.side]), o = F(() => e.side === p.old ? p[p.new] : p[p.old]), c = F(() => `tr[data-line="${e.lineNumber}-extend"]`), f = F(() => e.side === p.old ? ".old-diff-table-wrapper" : ".new-diff-table-wrapper"), h = L(e.diffFile.getSplitLeftLine(e.index)), w = L(e.diffFile.getSplitRightLine(e.index)), m = L(e.diffFile.getExpandEnabled()), g = L((i = (n = u.value) === null || n === void 0 ? void 0 : n.oldFile) === null || i === void 0 ? void 0 : i[(d = h.value) === null || d === void 0 ? void 0 : d.lineNumber]), b = L((s = (l = u.value) === null || l === void 0 ? void 0 : l.newFile) === null || s === void 0 ? void 0 : s[w.value.lineNumber]), x = F(() => e.side === p.old ? h.value : w.value);
  U(e, (H) => {
    var G, z, q, ne, ie;
    h.value = H.getSplitLeftLine(e.index), w.value = H.getSplitRightLine(e.index), g.value = (z = (G = u.value) === null || G === void 0 ? void 0 : G.oldFile) === null || z === void 0 ? void 0 : z[(q = h.value) === null || q === void 0 ? void 0 : q.lineNumber], b.value = (ie = (ne = u.value) === null || ne === void 0 ? void 0 : ne.newFile) === null || ie === void 0 ? void 0 : ie[w.value.lineNumber], m.value = H.getExpandEnabled();
  });
  const _ = F(() => e.side === p.old ? g.value : b.value), N = F(() => e.side === p.old ? h.value.lineNumber : w.value.lineNumber), S = F(() => !!((g.value || b.value) && (!x.value.isHidden || m.value) && a.extend)), y = F(() => e.side === p.new && S.value), D = F(() => (e.side === p.old ? !!g.value : !!b.value) && S.value);
  wn({
    selector: c,
    side: _.value ? v : o,
    enable: y
  });
  const k = bn({
    selector: f,
    enable: D
  });
  return () => {
    var H;
    return S.value ? t("tr", {
      "data-line": `${e.lineNumber}-extend`,
      "data-state": "extend",
      "data-side": p[e.side],
      class: "diff-line diff-line-extend"
    }, [_.value ? t("td", {
      class: `diff-line-extend-${p[e.side]}-content p-0`,
      colspan: 2
    }, [t("div", {
      class: "diff-line-extend-wrapper sticky left-0",
      style: {
        width: k.value + "px"
      }
    }, [k.value > 0 && ((H = a.extend) === null || H === void 0 ? void 0 : H.call(a, {
      diffFile: e.diffFile,
      side: e.side,
      lineNumber: N.value,
      data: _.value.data,
      onUpdate: e.diffFile.notifyAll
    }))])]) : t("td", {
      class: `diff-line-extend-${p[e.side]}-placeholder p-0 select-none`,
      style: {
        backgroundColor: `var(${xe})`
      },
      colspan: 2
    }, [t("span", null, [$(" ")])])]) : null;
  };
}, {
  name: "DiffSplitExtendLine",
  props: ["index", "diffFile", "lineNumber", "side"]
}), Q = ({
  className: e
}) => t("svg", {
  "aria-hidden": "true",
  height: "16",
  viewBox: "0 0 16 16",
  version: "1.1",
  width: "16",
  class: e
}, [t("path", {
  d: "m8.177 14.323 2.896-2.896a.25.25 0 0 0-.177-.427H8.75V7.764a.75.75 0 1 0-1.5 0V11H5.104a.25.25 0 0 0-.177.427l2.896 2.896a.25.25 0 0 0 .354 0ZM2.25 5a.75.75 0 0 0 0-1.5h-.5a.75.75 0 0 0 0 1.5h.5ZM6 4.25a.75.75 0 0 1-.75.75h-.5a.75.75 0 0 1 0-1.5h.5a.75.75 0 0 1 .75.75ZM8.25 5a.75.75 0 0 0 0-1.5h-.5a.75.75 0 0 0 0 1.5h.5ZM12 4.25a.75.75 0 0 1-.75.75h-.5a.75.75 0 0 1 0-1.5h.5a.75.75 0 0 1 .75.75Zm2.25.75a.75.75 0 0 0 0-1.5h-.5a.75.75 0 0 0 0 1.5h.5Z"
}, null)]), Y = ({
  className: e
}) => t("svg", {
  "aria-hidden": "true",
  height: "16",
  viewBox: "0 0 16 16",
  version: "1.1",
  width: "16",
  class: e
}, [t("path", {
  d: "M7.823 1.677 4.927 4.573A.25.25 0 0 0 5.104 5H7.25v3.236a.75.75 0 1 0 1.5 0V5h2.146a.25.25 0 0 0 .177-.427L8.177 1.677a.25.25 0 0 0-.354 0ZM13.75 11a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Zm-3.75.75a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75ZM7.75 11a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5ZM4 11.75a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75ZM1.75 11a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
}, null)]), Ve = ({
  className: e
}) => t("svg", {
  "aria-hidden": "true",
  height: "16",
  viewBox: "0 0 16 16",
  version: "1.1",
  width: "16",
  class: e
}, [t("path", {
  d: "m8.177.677 2.896 2.896a.25.25 0 0 1-.177.427H8.75v1.25a.75.75 0 0 1-1.5 0V4H5.104a.25.25 0 0 1-.177-.427L7.823.677a.25.25 0 0 1 .354 0ZM7.25 10.75a.75.75 0 0 1 1.5 0V12h2.146a.25.25 0 0 1 .177.427l-2.896 2.896a.25.25 0 0 1-.354 0l-2.896-2.896A.25.25 0 0 1 5.104 12H7.25v-1.25Zm-5-2a.75.75 0 0 0 0-1.5h-.5a.75.75 0 0 0 0 1.5h.5ZM6 8a.75.75 0 0 1-.75.75h-.5a.75.75 0 0 1 0-1.5h.5A.75.75 0 0 1 6 8Zm2.25.75a.75.75 0 0 0 0-1.5h-.5a.75.75 0 0 0 0 1.5h.5ZM12 8a.75.75 0 0 1-.75.75h-.5a.75.75 0 0 1 0-1.5h.5A.75.75 0 0 1 12 8Zm2.25.75a.75.75 0 0 0 0-1.5h-.5a.75.75 0 0 0 0 1.5h.5Z"
}, null)]), gn = () => {
  const e = window.getSelection();
  for (let n = 0; n < e.rangeCount; n++)
    e.removeRange(e.getRangeAt(n));
}, at = (e, n) => {
  const i = function(d) {
    d === null || d.target === null || (d.target === e ? (n.scrollTop = e.scrollTop, n.scrollLeft = e.scrollLeft) : (e.scrollTop = n.scrollTop, e.scrollLeft = n.scrollLeft));
  };
  return e.onscroll || (e.onscroll = i), n.onscroll || (n.onscroll = i), () => {
    e.onscroll = null, n.onscroll = null;
  };
}, A = "--diff-aside-width--", ot = /* @__PURE__ */ M((e) => {
  const n = L(e.diffFile.getSplitHunkLine(e.index)), i = L(e.diffFile.getExpandEnabled()), d = F(() => i.value && n.value && n.value.splitInfo), l = F(() => `tr[data-line="${e.lineNumber}-hunk"]`), s = F(() => e.side === p.old), u = F(() => p[p.old]), a = L(n.value && n.value.splitInfo && n.value.splitInfo.endHiddenIndex - n.value.splitInfo.startHiddenIndex < E), v = L(n.value && n.value.index === 0), o = L(n.value && !n.value.splitInfo), c = L(n.value && n.value.isLast), f = L(n.value && n.value.splitInfo && n.value.splitInfo.startHiddenIndex < n.value.splitInfo.endHiddenIndex);
  U(e, (w) => {
    n.value = w.getSplitHunkLine(e.index), i.value = w.getExpandEnabled(), a.value = n.value && n.value.splitInfo && n.value.splitInfo.endHiddenIndex - n.value.splitInfo.startHiddenIndex < E, f.value = n.value && n.value.splitInfo && n.value.splitInfo.startHiddenIndex < n.value.splitInfo.endHiddenIndex, v.value = n.value && n.value.index === 0, c.value = n.value && n.value.isLast, o.value = n.value && w._getIsPureDiffRender() && !n.value.splitInfo;
  });
  const h = F(() => e.side === p.new && f.value);
  return wn({
    selector: l,
    side: u,
    enable: h
  }), () => {
    var w;
    return !f.value && !o.value ? null : t("tr", {
      "data-line": `${e.lineNumber}-hunk`,
      "data-state": "hunk",
      "data-side": p[e.side],
      style: {
        backgroundColor: `var(${ge})`
      },
      class: "diff-line diff-line-hunk"
    }, [s.value ? t(X, null, [t("td", {
      class: "diff-line-hunk-action sticky left-0 p-[1px] w-[1%] min-w-[40px] select-none",
      style: {
        backgroundColor: `var(${Pe})`,
        color: `var(${ee})`,
        width: `var(${A})`,
        minWidth: `var(${A})`,
        maxWidth: `var(${A})`
      }
    }, [d.value ? v.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand Up",
      "data-title": "Expand Up",
      onClick: () => e.diffFile.onSplitHunkExpand("up", e.index)
    }, [t(Y, {
      className: "fill-current"
    }, null)]) : c.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand Down",
      "data-title": "Expand Down",
      onClick: () => e.diffFile.onSplitHunkExpand("down", e.index)
    }, [t(Q, {
      className: "fill-current"
    }, null)]) : a.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand All",
      "data-title": "Expand All",
      onClick: () => e.diffFile.onSplitHunkExpand("all", e.index)
    }, [t(Ve, {
      className: "fill-current"
    }, null)]) : t(X, null, [t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[2px] cursor-pointer rounded-[2px]",
      title: "Expand Down",
      "data-title": "Expand Down",
      onClick: () => e.diffFile.onSplitHunkExpand("down", e.index)
    }, [t(Q, {
      className: "fill-current"
    }, null)]), t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[2px] cursor-pointer rounded-[2px]",
      title: "Expand Up",
      "data-title": "Expand Up",
      onClick: () => e.diffFile.onSplitHunkExpand("up", e.index)
    }, [t(Y, {
      className: "fill-current"
    }, null)])]) : t("div", {
      class: "min-h-[28px]"
    }, [$(" ")])]), t("td", {
      class: "diff-line-hunk-content pr-[10px] align-middle",
      style: {
        backgroundColor: `var(${ge})`
      }
    }, [t("div", {
      class: "pl-[1.5em]",
      style: {
        color: `var(${Ue})`
      }
    }, [((w = n.value.splitInfo) === null || w === void 0 ? void 0 : w.plainText) || n.value.text])])]) : t("td", {
      class: "diff-line-hunk-placeholder select-none",
      colspan: 2,
      style: {
        backgroundColor: `var(${ge})`
      }
    }, [t("div", {
      class: "min-h-[28px]"
    }, [$(" ")])])]);
  };
}, {
  name: "DiffSplitHunkLine",
  props: ["diffFile", "index", "lineNumber", "side"]
}), ut = /* @__PURE__ */ M((e) => {
  const n = L(e.diffFile.getSplitHunkLine(e.index)), i = L(e.diffFile.getExpandEnabled()), d = F(() => `tr[data-line="${e.lineNumber}-hunk"]`), l = F(() => i.value && n.value && n.value.splitInfo), s = L(n.value && n.value.splitInfo && n.value.splitInfo.endHiddenIndex - n.value.splitInfo.startHiddenIndex < E), u = L(n.value && n.value.index === 0), a = L(n.value && !n.value.splitInfo), v = L(n.value && n.value.isLast), o = L(n.value && n.value.splitInfo && n.value.splitInfo.startHiddenIndex < n.value.splitInfo.endHiddenIndex), c = F(() => p[p.old]), f = F(() => e.side === p.new && o.value);
  return wn({
    selector: d,
    side: c,
    enable: f
  }), U(e, (h) => {
    n.value = h.getSplitHunkLine(e.index), i.value = h.getExpandEnabled(), s.value = n.value && n.value.splitInfo && n.value.splitInfo.endHiddenIndex - n.value.splitInfo.startHiddenIndex < E, o.value = n.value && n.value.splitInfo && n.value.splitInfo.startHiddenIndex < n.value.splitInfo.endHiddenIndex, u.value = n.value && n.value.index === 0, v.value = n.value && n.value.isLast, a.value = n.value && h._getIsPureDiffRender() && !n.value.splitInfo;
  }), () => {
    var h;
    return !o.value && !a.value ? null : t("tr", {
      "data-line": `${e.lineNumber}-hunk`,
      "data-state": "hunk",
      "data-side": p[e.side],
      style: {
        backgroundColor: `var(${ge})`
      },
      class: "diff-line diff-line-hunk"
    }, [t("td", {
      class: "diff-line-hunk-action sticky left-0 p-[1px] w-[1%] min-w-[40px] select-none",
      style: {
        backgroundColor: `var(${Pe})`,
        color: `var(${ee})`,
        width: `var(${A})`,
        minWidth: `var(${A})`,
        maxWidth: `var(${A})`
      }
    }, [l.value ? u.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand Up",
      "data-title": "Expand Up",
      onClick: () => e.diffFile.onSplitHunkExpand("up", e.index)
    }, [t(Y, {
      className: "fill-current"
    }, null)]) : v.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand Down",
      "data-title": "Expand Down",
      onClick: () => e.diffFile.onSplitHunkExpand("down", e.index)
    }, [t(Q, {
      className: "fill-current"
    }, null)]) : s.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand All",
      "data-title": "Expand All",
      onClick: () => e.diffFile.onSplitHunkExpand("all", e.index)
    }, [t(Ve, {
      className: "fill-current"
    }, null)]) : t(X, null, [t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[2px] cursor-pointer rounded-[2px]",
      title: "Expand Down",
      "data-title": "Expand Down",
      onClick: () => e.diffFile.onSplitHunkExpand("down", e.index)
    }, [t(Q, {
      className: "fill-current"
    }, null)]), t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[2px] cursor-pointer rounded-[2px]",
      title: "Expand Up",
      "data-title": "Expand Up",
      onClick: () => e.diffFile.onSplitHunkExpand("up", e.index)
    }, [t(Y, {
      className: "fill-current"
    }, null)])]) : t("div", {
      class: "min-h-[28px]"
    }, [$(" ")])]), t("td", {
      class: "diff-line-hunk-content pr-[10px] align-middle",
      style: {
        backgroundColor: `var(${ge})`
      }
    }, [t("div", {
      class: "pl-[1.5em]",
      style: {
        color: `var(${Ue})`
      }
    }, [((h = n.value.splitInfo) === null || h === void 0 ? void 0 : h.plainText) || n.value.text])])]);
  };
}, {
  name: "DiffSplitHunkLine",
  props: ["diffFile", "index", "lineNumber", "side"]
}), Gn = /* @__PURE__ */ M((e) => {
  const n = pi();
  return () => n.value === oe.SplitGitHub || n.value === oe.Split ? t(ot, {
    index: e.index,
    side: e.side,
    diffFile: e.diffFile,
    lineNumber: e.lineNumber
  }, null) : t(ut, {
    index: e.index,
    side: e.side,
    diffFile: e.diffFile,
    lineNumber: e.lineNumber
  }, null);
}, {
  name: "DiffSplitHunkLine",
  props: ["diffFile", "index", "lineNumber", "side"]
}), en = ({
  side: e,
  className: n,
  lineNumber: i,
  onWidgetClick: d,
  onOpenAddWidget: l
}) => t("div", {
  class: "diff-add-widget-wrapper" + (n ? " " + n : ""),
  style: {
    width: `calc(var(${J}) * 1.4)`,
    height: `calc(var(${J}) * 1.4)`
  }
}, [t("button", {
  class: "diff-add-widget w-full h-full invisible cursor-pointer rounded-md flex items-center justify-center transition-transform origin-center group-hover:visible hover:scale-110",
  style: {
    color: `var(${Di})`,
    zIndex: 1,
    fontSize: "1.2em",
    backgroundColor: `var(${Ci})`
  },
  onClick: () => {
    l(i, e), d == null || d("onAddWidgetClick", i, e);
  }
}, [$("+")])]), On = ({
  lineNumber: e,
  side: n,
  onWidgetClick: i,
  onOpenAddWidget: d
}) => t("div", {
  class: "diff-add-widget-wrapper absolute left-[100%] top-[1px] translate-x-[-50%]",
  style: {
    width: `calc(var(${J}) * 1.4)`,
    height: `calc(var(${J}) * 1.4)`
  }
}, [t("button", {
  class: "diff-add-widget w-full h-full invisible cursor-pointer rounded-md flex items-center justify-center transition-transform origin-center group-hover:visible hover:scale-110",
  style: {
    color: `var(${Di})`,
    zIndex: 1,
    fontSize: "1.2em",
    backgroundColor: `var(${Ci})`
  },
  onClick: () => {
    d(e, n), i == null || i("onAddWidgetClick", e, n);
  }
}, [$("+")])]), $i = () => t("svg", {
  "aria-label": "No newline at end of file",
  role: "img",
  viewBox: "0 0 16 16",
  version: "1.1",
  fill: "currentColor"
}, [t("path", {
  d: "M4.25 7.25a.75.75 0 0 0 0 1.5h7.5a.75.75 0 0 0 0-1.5h-7.5Z"
}, null), t("path", {
  d: "M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0Zm-1.5 0a6.5 6.5 0 1 0-13 0 6.5 6.5 0 0 0 13 0Z"
}, null)]), Wi = ({
  rawLine: e,
  diffLine: n,
  operator: i,
  enableWrap: d
}) => {
  const l = n == null ? void 0 : n.range;
  if (l) {
    const s = e.slice(0, l.location), u = e.slice(l.location, l.location + l.length), a = e.slice(l.location + l.length), v = u.includes(`
`), o = v ? u.replace(`
`, "") : u, c = a === "" ? l.newLineSymbol : null;
    return t("span", {
      class: "diff-line-content-raw"
    }, [t("span", {
      "data-range-start": l.location,
      "data-range-end": l.location + l.length
    }, [s, t("span", {
      "data-diff-highlight": !0,
      class: "rounded-[0.2em]",
      style: {
        backgroundColor: i === "add" ? `var(${Hi})` : `var(${Ei})`
      }
    }, [v ? `${o}${c === T.LF ? "␊" : c === T.CR ? "␍" : c === T.CRLF ? "␍␊" : ""}` : u]), a]), c === T.NEWLINE && n.noTrailingNewLine && t("span", {
      "data-no-newline-at-end-of-file": !0,
      class: d ? "block text-red-500" : "inline-block align-middle text-red-500",
      style: {
        width: `var(${J})`,
        height: `var(${J})`
      }
    }, [t($i, null, null)])]);
  }
  return t("span", {
    class: "diff-line-content-raw"
  }, [e]);
}, ft = ({
  rawLine: e,
  diffLine: n,
  operator: i,
  syntaxLine: d,
  enableWrap: l
}) => {
  var s, u;
  if (!d)
    return t(Wi, {
      rawLine: e,
      diffLine: n,
      operator: i
    }, null);
  const a = n == null ? void 0 : n.range;
  if (a) {
    const v = a.newLineSymbol;
    return t("span", {
      class: "diff-line-syntax-raw"
    }, [t("span", {
      "data-range-start": a.location,
      "data-range-end": a.location + a.length
    }, [(s = d.nodeList) === null || s === void 0 ? void 0 : s.map(({
      node: o,
      wrapper: c
    }, f) => {
      var h, w, m, g, b, x;
      if (o.endIndex < a.location || a.location + a.length < o.startIndex)
        return t("span", {
          key: f,
          "data-start": o.startIndex,
          "data-end": o.endIndex,
          class: (w = (h = c == null ? void 0 : c.properties) === null || h === void 0 ? void 0 : h.className) === null || w === void 0 ? void 0 : w.join(" "),
          style: (m = c == null ? void 0 : c.properties) === null || m === void 0 ? void 0 : m.style
        }, [o.value]);
      {
        const _ = a.location - o.startIndex, N = _ < 0 ? 0 : _, S = o.value.slice(0, N), y = o.value.slice(N, _ + a.length), D = o.value.slice(_ + a.length), k = S.length || a.location === o.startIndex, H = D.length || o.endIndex === a.location + a.length - 1, G = y.includes(`
`), z = G ? y.replace(`
`, "") : y;
        return t("span", {
          key: f,
          "data-start": o.startIndex,
          "data-end": o.endIndex,
          class: (b = (g = c == null ? void 0 : c.properties) === null || g === void 0 ? void 0 : g.className) === null || b === void 0 ? void 0 : b.join(" "),
          style: (x = c == null ? void 0 : c.properties) === null || x === void 0 ? void 0 : x.style
        }, [S, t("span", {
          "data-diff-highlight": !0,
          style: {
            backgroundColor: i === "add" ? `var(${Hi})` : `var(${Ei})`,
            borderTopLeftRadius: k ? "0.2em" : void 0,
            borderBottomLeftRadius: k ? "0.2em" : void 0,
            borderTopRightRadius: H || G ? "0.2em" : void 0,
            borderBottomRightRadius: H || G ? "0.2em" : void 0
          }
        }, [G ? `${z}${v === T.LF ? "␊" : v === T.CR ? "␍" : v === T.CRLF ? "␍␊" : ""}` : y]), D]);
      }
    })]), v === T.NEWLINE && n.noTrailingNewLine && t("span", {
      "data-no-newline-at-end-of-file": !0,
      class: l ? "block text-red-500" : "inline-block align-middle text-red-500",
      style: {
        width: `var(${J})`,
        height: `var(${J})`
      }
    }, [t($i, null, null)])]);
  }
  return t("span", {
    class: "diff-line-syntax-raw"
  }, [(u = d == null ? void 0 : d.nodeList) === null || u === void 0 ? void 0 : u.map(({
    node: v,
    wrapper: o
  }, c) => {
    var f, h, w;
    return t("span", {
      key: c,
      "data-start": v.startIndex,
      "data-end": v.endIndex,
      class: (h = (f = o == null ? void 0 : o.properties) === null || f === void 0 ? void 0 : f.className) === null || h === void 0 ? void 0 : h.join(" "),
      style: (w = o == null ? void 0 : o.properties) === null || w === void 0 ? void 0 : w.style
    }, [v.value]);
  })]);
}, Ge = ({
  diffLine: e,
  rawLine: n,
  syntaxLine: i,
  enableWrap: d,
  enableHighlight: l
}) => {
  var s;
  const u = (e == null ? void 0 : e.type) === C.Add, a = (e == null ? void 0 : e.type) === C.Delete, v = ((s = i == null ? void 0 : i.nodeList) === null || s === void 0 ? void 0 : s.length) > 150;
  return t("div", {
    class: "diff-line-content-item pl-[2.0em]",
    "data-val": n,
    style: {
      whiteSpace: d ? "pre-wrap" : "pre",
      wordBreak: d ? "break-all" : "initial"
    }
  }, [t("span", {
    "data-operator": u ? "+" : a ? "-" : void 0,
    class: "diff-line-content-operator inline-block w-[1.5em] ml-[-1.5em] indent-[0.2em] select-none"
  }, [u ? "+" : a ? "-" : " "]), l && i && !v ? t(ft, {
    operator: u ? "add" : a ? "del" : void 0,
    rawLine: n,
    diffLine: e,
    syntaxLine: i,
    enableWrap: d
  }, null) : t(Wi, {
    operator: u ? "add" : a ? "del" : void 0,
    rawLine: n,
    diffLine: e,
    enableWrap: d
  }, null)]);
}, rt = /* @__PURE__ */ M((e) => {
  var n, i, d, l, s;
  const u = Ze(), a = $n(), v = Dn(), o = An(), c = L(e.side === p.old ? e.diffFile.getSplitLeftLine(e.index) : e.diffFile.getSplitRightLine(e.index)), f = L(!!(!((n = c.value) === null || n === void 0) && n.diff)), h = L(be((i = c.value) === null || i === void 0 ? void 0 : i.diff)), w = L((d = c.value) === null || d === void 0 ? void 0 : d.isHidden), m = L(c.value.lineNumber), g = L(e.side === p.old ? e.diffFile.getOldSyntaxLine((l = c.value) === null || l === void 0 ? void 0 : l.lineNumber) : e.diffFile.getNewSyntaxLine((s = c.value) === null || s === void 0 ? void 0 : s.lineNumber));
  return U(e, (b) => {
    var x, _, N, S, y;
    c.value = e.side === p.old ? b.getSplitLeftLine(e.index) : b.getSplitRightLine(e.index), g.value = e.side === p.old ? b.getOldSyntaxLine((x = c.value) === null || x === void 0 ? void 0 : x.lineNumber) : b.getNewSyntaxLine((_ = c.value) === null || _ === void 0 ? void 0 : _.lineNumber), f.value = !!(!((N = c.value) === null || N === void 0) && N.diff), h.value = be((S = c.value) === null || S === void 0 ? void 0 : S.diff), w.value = (y = c.value) === null || y === void 0 ? void 0 : y.isHidden, m.value = c.value.lineNumber;
  }), () => {
    var b, x, _, N;
    if (w.value)
      return null;
    const S = ((x = (b = c.value) === null || b === void 0 ? void 0 : b.diff) === null || x === void 0 ? void 0 : x.type) === C.Add, y = ((N = (_ = c.value) === null || _ === void 0 ? void 0 : _.diff) === null || N === void 0 ? void 0 : N.type) === C.Delete, D = kn(S, y, f.value), k = Hn(S, y, f.value);
    return t("tr", {
      "data-line": e.lineNumber,
      "data-state": f.value || !m.value ? "diff" : "plain",
      "data-side": p[e.side],
      class: "diff-line" + (m.value ? " group" : "")
    }, [m.value ? t(X, null, [t("td", {
      class: `diff-line-${p[e.side]}-num sticky left-0 pl-[10px] pr-[10px] text-right align-top select-none w-[1%] min-w-[40px]`,
      style: {
        backgroundColor: k,
        color: `var(${ee})`,
        width: `var(${A})`,
        minWidth: `var(${A})`,
        maxWidth: `var(${A})`
      }
    }, [f.value && a.value && t(en, {
      index: e.index,
      lineNumber: c.value.lineNumber,
      side: e.side,
      diffFile: e.diffFile,
      onWidgetClick: o,
      className: "absolute left-[100%] translate-x-[-50%] z-[1]",
      onOpenAddWidget: (H, G) => u({
        lineNumber: H,
        side: G
      })
    }, null), t("span", {
      "data-line-num": c.value.lineNumber,
      style: {
        opacity: h.value ? void 0 : 0.5
      }
    }, [c.value.lineNumber])]), t("td", {
      class: `diff-line-${p[e.side]}-content pr-[10px] align-top`,
      style: {
        backgroundColor: D
      }
    }, [t(Ge, {
      enableWrap: !1,
      diffFile: e.diffFile,
      rawLine: c.value.value,
      diffLine: c.value.diff,
      syntaxLine: g.value,
      enableHighlight: v.value
    }, null)])]) : t("td", {
      class: `diff-line-${p[e.side]}-placeholder select-none`,
      style: {
        backgroundColor: `var(${xe})`
      },
      colspan: 2
    }, [t("span", null, [$(" ")])])]);
  };
}, {
  name: "DiffSplitLine",
  props: ["diffFile", "index", "lineNumber", "side"]
}), ct = /* @__PURE__ */ M((e) => {
  const n = ze(), i = Mn(), d = Ze(), l = L(e.diffFile.getSplitLeftLine(e.index)), s = L(e.diffFile.getSplitRightLine(e.index)), u = F(() => l.value.lineNumber && i.value.side === p.old && i.value.lineNumber === l.value.lineNumber), a = F(() => s.value.lineNumber && i.value.side === p.new && i.value.lineNumber === s.value.lineNumber);
  U(e, (x) => {
    l.value = x.getSplitLeftLine(e.index), s.value = x.getSplitRightLine(e.index);
  });
  const v = F(() => e.side === p.old ? l.value : s.value), o = F(() => `tr[data-line="${e.lineNumber}-widget"]`), c = F(() => e.side === p.old ? ".old-diff-table-wrapper" : ".new-diff-table-wrapper"), f = F(() => e.side === p.old ? p.new : p.old), h = F(() => m.value ? p[e.side] : p[f.value]), w = F(() => !!u.value || !!a.value), m = F(() => (e.side === p.old ? u.value : a.value) && !!w.value && !!n.widget), g = () => d({});
  wn({
    selector: o,
    side: h,
    enable: m
  });
  const b = bn({
    selector: c,
    enable: m
  });
  return () => {
    var x;
    return !w.value || !n.widget ? null : t("tr", {
      "data-line": `${e.lineNumber}-widget`,
      "data-state": "widget",
      "data-side": p[e.side],
      class: "diff-line diff-line-widget"
    }, [m.value ? t("td", {
      class: `diff-line-widget-${p[e.side]}-content p-0`,
      colspan: 2
    }, [t("div", {
      class: "diff-line-widget-wrapper sticky left-0",
      style: {
        width: b.value + "px"
      }
    }, [b.value > 0 && ((x = n.widget) === null || x === void 0 ? void 0 : x.call(n, {
      diffFile: e.diffFile,
      side: e.side,
      lineNumber: v.value.lineNumber,
      onClose: g
    }))])]) : t("td", {
      class: `diff-line-widget-${p[e.side]}-placeholder p-0 select-none`,
      style: {
        backgroundColor: `var(${xe})`
      },
      colspan: 2
    }, [t("span", null, [$(" ")])])]);
  };
}, {
  name: "DiffSplitWidgetLine",
  props: ["diffFile", "index", "lineNumber", "side"]
}), zn = /* @__PURE__ */ M((e) => {
  const n = F(() => e.side === p.new ? "new-diff-table" : "old-diff-table"), i = L(vn(e.diffFile));
  U(e, (l) => {
    i.value = vn(l);
  });
  const d = (l) => {
    const s = l.target;
    if (s && s instanceof HTMLElement && s.nodeName === "BUTTON") {
      gn();
      return;
    }
  };
  return () => t("table", {
    class: n.value + " border-collapse w-full",
    "data-mode": p[e.side]
  }, [t("colgroup", null, [t("col", {
    class: `diff-table-${p[e.side]}-num-col`
  }, null), t("col", {
    class: `diff-table-${p[e.side]}-content-col`
  }, null)]), t("thead", {
    class: "hidden"
  }, [t("tr", null, [t("th", {
    scope: "col"
  }, [p[e.side], $(" line number")]), t("th", {
    scope: "col"
  }, [p[e.side], $(" line content")])])]), t("tbody", {
    class: "diff-table-body leading-[1.4]",
    onMousedown: d
  }, [i.value.map((l) => t(X, {
    key: l.index
  }, [t(Gn, {
    index: l.index,
    side: e.side,
    lineNumber: l.lineNumber,
    diffFile: e.diffFile
  }, null), t(rt, {
    index: l.index,
    side: e.side,
    lineNumber: l.lineNumber,
    diffFile: e.diffFile
  }, null), t(ct, {
    index: l.index,
    side: e.side,
    lineNumber: l.lineNumber,
    diffFile: e.diffFile
  }, null), t(st, {
    index: l.index,
    side: e.side,
    lineNumber: l.lineNumber,
    diffFile: e.diffFile
  }, null)])), t(Gn, {
    side: e.side,
    index: e.diffFile.splitLineLength,
    lineNumber: e.diffFile.splitLineLength,
    diffFile: e.diffFile
  }, null)])]);
}, {
  name: "DiffSplitViewTable",
  props: ["diffFile", "side"]
}), vt = /* @__PURE__ */ M((e) => {
  const n = ln(), i = L(), d = L(), l = L(e.diffFile.splitLineLength.toString());
  U(e, (c) => {
    l.value = c.splitLineLength.toString();
  }), xn((c) => {
    if (!n.value)
      return;
    const f = i.value, h = d.value;
    if (!f || !h)
      return;
    const w = at(f, h);
    c(w);
  });
  const u = En(), a = F(() => ({
    fontSize: u.value + "px",
    fontFamily: "Menlo, Consolas, monospace"
  })), v = Rn({
    text: l,
    font: a
  }), o = F(() => Math.max(40, v.value + 25));
  return () => t("div", {
    class: "split-diff-view split-diff-view-wrap w-full flex basis-[50%]"
  }, [t("div", {
    class: "old-diff-table-wrapper overflow-x-auto overflow-y-hidden w-full scrollbar-hide",
    ref: i,
    style: {
      [A]: `${Math.round(o.value)}px`,
      overscrollBehaviorX: "none",
      fontFamily: "Menlo, Consolas, monospace",
      fontSize: `var(${J})`
    }
  }, [t(zn, {
    side: p.old,
    diffFile: e.diffFile
  }, null)]), t("div", {
    class: "diff-split-line w-[1.5px] bg-[rgb(222,222,222)]"
  }, null), t("div", {
    class: "new-diff-table-wrapper overflow-x-auto overflow-y-hidden w-full scrollbar-hide",
    ref: d,
    style: {
      [A]: `${Math.round(o.value)}px`,
      overscrollBehaviorX: "none",
      fontFamily: "Menlo, Consolas, monospace",
      fontSize: `var(${J})`
    }
  }, [t(zn, {
    side: p.new,
    diffFile: e.diffFile
  }, null)])]);
}, {
  name: "DiffSplitViewNormal",
  props: ["diffFile"]
}), ht = /* @__PURE__ */ M((e) => {
  var n, i, d, l, s;
  const u = Wn(), a = ze(), v = L(e.diffFile.getSplitLeftLine(e.index)), o = L(e.diffFile.getSplitRightLine(e.index)), c = L(e.diffFile.getExpandEnabled()), f = L((i = (n = u.value) === null || n === void 0 ? void 0 : n.oldFile) === null || i === void 0 ? void 0 : i[(d = v.value) === null || d === void 0 ? void 0 : d.lineNumber]), h = L((s = (l = u.value) === null || l === void 0 ? void 0 : l.newFile) === null || s === void 0 ? void 0 : s[o.value.lineNumber]);
  U(e, (m) => {
    var g, b, x, _, N;
    v.value = m.getSplitLeftLine(e.index), o.value = m.getSplitRightLine(e.index), f.value = (b = (g = u.value) === null || g === void 0 ? void 0 : g.oldFile) === null || b === void 0 ? void 0 : b[(x = v.value) === null || x === void 0 ? void 0 : x.lineNumber], h.value = (N = (_ = u.value) === null || _ === void 0 ? void 0 : _.newFile) === null || N === void 0 ? void 0 : N[o.value.lineNumber], c.value = m.getExpandEnabled();
  });
  const w = F(() => {
    var m, g;
    return !!((f.value || h.value) && (!(!((m = v.value) === null || m === void 0) && m.isHidden) && !(!((g = o.value) === null || g === void 0) && g.isHidden) || c.value));
  });
  return () => {
    var m, g;
    return w.value ? t("tr", {
      "data-line": `${e.lineNumber}-extend`,
      "data-state": "extend",
      class: "diff-line diff-line-extend"
    }, [f.value ? t("td", {
      class: "diff-line-extend-old-content p-0",
      colspan: 2
    }, [t("div", {
      class: "diff-line-extend-wrapper"
    }, [(m = a.extend) === null || m === void 0 ? void 0 : m.call(a, {
      diffFile: e.diffFile,
      side: p.old,
      lineNumber: v.value.lineNumber,
      data: f.value.data,
      onUpdate: e.diffFile.notifyAll
    })])]) : t("td", {
      class: "diff-line-extend-old-placeholder p-0 select-none",
      style: {
        backgroundColor: `var(${xe})`
      },
      colspan: 2
    }, [t("span", null, [$(" ")])]), h.value ? t("td", {
      class: "diff-line-extend-new-content p-0 border-l-[1px] border-l-[rgb(222,222,222)]",
      colspan: 2
    }, [t("div", {
      class: "diff-line-extend-wrapper"
    }, [(g = a.extend) === null || g === void 0 ? void 0 : g.call(a, {
      diffFile: e.diffFile,
      side: p.new,
      lineNumber: o.value.lineNumber,
      data: h.value.data,
      onUpdate: e.diffFile.notifyAll
    })])]) : t("td", {
      class: "diff-line-extend-new-placeholder p-0 border-l-[1px] border-l-[rgb(222,222,222)] select-none",
      style: {
        backgroundColor: `var(${xe})`
      },
      colspan: 2
    }, [t("span", null, [$(" ")])])]) : null;
  };
}, {
  name: "DiffSplitExtendLine",
  props: ["index", "diffFile", "lineNumber"]
}), gt = /* @__PURE__ */ M((e) => {
  const n = L(e.diffFile.getSplitHunkLine(e.index)), i = L(e.diffFile.getExpandEnabled()), d = F(() => i.value && n.value && n.value.splitInfo), l = L(n.value && n.value.splitInfo && n.value.splitInfo.endHiddenIndex - n.value.splitInfo.startHiddenIndex < E), s = L(n.value && n.value.splitInfo && n.value.splitInfo.startHiddenIndex < n.value.splitInfo.endHiddenIndex), u = L(n.value && n.value.index === 0), a = L(n.value && !n.value.splitInfo), v = L(n.value && n.value.isLast);
  return U(e, (o) => {
    n.value = o.getSplitHunkLine(e.index), i.value = o.getExpandEnabled(), l.value = n.value && n.value.splitInfo && n.value.splitInfo.endHiddenIndex - n.value.splitInfo.startHiddenIndex < E, s.value = n.value && n.value.splitInfo && n.value.splitInfo.startHiddenIndex < n.value.splitInfo.endHiddenIndex, u.value = n.value && n.value.index === 0, v.value = n.value && n.value.isLast, a.value = n.value && o._getIsPureDiffRender() && !n.value.splitInfo;
  }), () => {
    var o;
    return !s.value && !a.value ? null : t("tr", {
      "data-line": `${e.lineNumber}-hunk`,
      "data-state": "hunk",
      class: "diff-line diff-line-hunk select-none"
    }, [t("td", {
      class: "diff-line-hunk-action p-[1px] w-[1%] min-w-[40px] select-none relative",
      style: {
        backgroundColor: `var(${Pe})`,
        color: `var(${ee})`
      }
    }, [d.value ? u.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand Up",
      "data-title": "Expand Up",
      onClick: () => e.diffFile.onSplitHunkExpand("up", e.index)
    }, [t(Y, {
      className: "fill-current"
    }, null)]) : v.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand Down",
      "data-title": "Expand Down",
      onClick: () => e.diffFile.onSplitHunkExpand("down", e.index)
    }, [t(Q, {
      className: "fill-current"
    }, null)]) : l.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand All",
      "data-title": "Expand All",
      onClick: () => e.diffFile.onSplitHunkExpand("all", e.index)
    }, [t(Ve, {
      className: "fill-current"
    }, null)]) : t(X, null, [t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[2px] cursor-pointer rounded-[2px]",
      title: "Expand Down",
      "data-title": "Expand Down",
      onClick: () => e.diffFile.onSplitHunkExpand("down", e.index)
    }, [t(Q, {
      className: "fill-current"
    }, null)]), t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[2px] cursor-pointer rounded-[2px]",
      title: "Expand Up",
      "data-title": "Expand Up",
      onClick: () => e.diffFile.onSplitHunkExpand("up", e.index)
    }, [t(Y, {
      className: "fill-current"
    }, null)])]) : t("div", {
      class: "min-h-[28px]"
    }, [$(" ")])]), t("td", {
      class: "diff-line-hunk-content pr-[10px] align-middle",
      style: {
        backgroundColor: `var(${ge})`
      },
      colspan: 3
    }, [t("div", {
      class: "pl-[1.5em]",
      style: {
        color: `var(${Ue})`
      }
    }, [((o = n.value.splitInfo) === null || o === void 0 ? void 0 : o.plainText) || n.value.text])])]);
  };
}, {
  name: "DiffSplitHunkLine",
  props: ["diffFile", "index", "lineNumber"]
}), xt = /* @__PURE__ */ M((e) => {
  const n = L(e.diffFile.getSplitHunkLine(e.index)), i = L(e.diffFile.getExpandEnabled()), d = F(() => i.value && n.value && n.value.splitInfo), l = L(n.value && n.value.splitInfo && n.value.splitInfo.endHiddenIndex - n.value.splitInfo.startHiddenIndex < E), s = L(n.value && n.value.splitInfo && n.value.splitInfo.startHiddenIndex < n.value.splitInfo.endHiddenIndex), u = L(n.value && n.value.index === 0), a = L(n.value && !n.value.splitInfo), v = L(n.value && n.value.isLast);
  return U(e, (o) => {
    n.value = o.getSplitHunkLine(e.index), i.value = o.getExpandEnabled(), l.value = n.value && n.value.splitInfo && n.value.splitInfo.endHiddenIndex - n.value.splitInfo.startHiddenIndex < E, s.value = n.value && n.value.splitInfo && n.value.splitInfo.startHiddenIndex < n.value.splitInfo.endHiddenIndex, u.value = n.value && n.value.index === 0, v.value = n.value && n.value.isLast, a.value = n.value && o._getIsPureDiffRender() && !n.value.splitInfo;
  }), () => {
    var o, c;
    return !s.value && !a.value ? null : t("tr", {
      "data-line": `${e.lineNumber}-hunk`,
      "data-state": "hunk",
      class: "diff-line diff-line-hunk select-none"
    }, [t("td", {
      class: "diff-line-hunk-action p-[1px] w-[1%] min-w-[40px] select-none relative",
      style: {
        backgroundColor: `var(${Pe})`,
        color: `var(${ee})`
      }
    }, [d.value ? u.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand Up",
      "data-title": "Expand Up",
      onClick: () => e.diffFile.onSplitHunkExpand("up", e.index)
    }, [t(Y, {
      className: "fill-current"
    }, null)]) : v.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand Down",
      "data-title": "Expand Down",
      onClick: () => e.diffFile.onSplitHunkExpand("down", e.index)
    }, [t(Q, {
      className: "fill-current"
    }, null)]) : l.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand All",
      "data-title": "Expand All",
      onClick: () => e.diffFile.onSplitHunkExpand("all", e.index)
    }, [t(Ve, {
      className: "fill-current"
    }, null)]) : t(X, null, [t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[2px] cursor-pointer rounded-[2px]",
      title: "Expand Down",
      "data-title": "Expand Down",
      onClick: () => e.diffFile.onSplitHunkExpand("down", e.index)
    }, [t(Q, {
      className: "fill-current"
    }, null)]), t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[2px] cursor-pointer rounded-[2px]",
      title: "Expand Up",
      "data-title": "Expand Up",
      onClick: () => e.diffFile.onSplitHunkExpand("up", e.index)
    }, [t(Y, {
      className: "fill-current"
    }, null)])]) : t("div", {
      class: "min-h-[28px]"
    }, [$(" ")])]), t("td", {
      class: "diff-line-hunk-content pr-[10px] align-middle",
      style: {
        backgroundColor: `var(${ge})`
      }
    }, [t("div", {
      class: "pl-[1.5em]",
      style: {
        color: `var(${Ue})`
      }
    }, [((o = n.value.splitInfo) === null || o === void 0 ? void 0 : o.plainText) || n.value.text])]), t("td", {
      class: "diff-line-hunk-action p-[1px] w-[1%] min-w-[40px] select-none relative border-l-[1px] border-l-[rgb(222,222,222)]",
      style: {
        backgroundColor: `var(${Pe})`,
        color: `var(${ee})`
      }
    }, [d.value ? u.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand Up",
      "data-title": "Expand Up",
      onClick: () => e.diffFile.onSplitHunkExpand("up", e.index)
    }, [t(Y, {
      className: "fill-current"
    }, null)]) : v.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand Down",
      "data-title": "Expand Down",
      onClick: () => e.diffFile.onSplitHunkExpand("down", e.index)
    }, [t(Q, {
      className: "fill-current"
    }, null)]) : l.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand All",
      "data-title": "Expand All",
      onClick: () => e.diffFile.onSplitHunkExpand("all", e.index)
    }, [t(Ve, {
      className: "fill-current"
    }, null)]) : t(X, null, [t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[2px] cursor-pointer rounded-[2px]",
      title: "Expand Down",
      "data-title": "Expand Down",
      onClick: () => e.diffFile.onSplitHunkExpand("down", e.index)
    }, [t(Q, {
      className: "fill-current"
    }, null)]), t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[2px] cursor-pointer rounded-[2px]",
      title: "Expand Up",
      "data-title": "Expand Up",
      onClick: () => e.diffFile.onSplitHunkExpand("up", e.index)
    }, [t(Y, {
      className: "fill-current"
    }, null)])]) : t("div", {
      class: "min-h-[28px]"
    }, [$(" ")])]), t("td", {
      class: "diff-line-hunk-content pr-[10px] align-middle",
      style: {
        backgroundColor: `var(${ge})`
      }
    }, [t("div", {
      class: "pl-[1.5em]",
      style: {
        color: `var(${Ue})`
      }
    }, [((c = n.value.splitInfo) === null || c === void 0 ? void 0 : c.plainText) || n.value.text])])]);
  };
}, {
  name: "DiffSplitHunkLine",
  props: ["diffFile", "index", "lineNumber"]
}), Zn = /* @__PURE__ */ M((e) => {
  const n = pi();
  return () => n.value === oe.SplitGitHub || n.value === oe.Split ? t(gt, {
    index: e.index,
    diffFile: e.diffFile,
    lineNumber: e.lineNumber
  }, null) : t(xt, {
    index: e.index,
    diffFile: e.diffFile,
    lineNumber: e.lineNumber
  }, null);
}, {
  name: "DiffSplitHunkLine",
  props: ["diffFile", "index", "lineNumber"]
}), bt = /* @__PURE__ */ M((e) => {
  var n, i, d, l, s, u, a, v, o, c, f, h;
  const w = Ze(), m = $n(), g = Dn(), b = An(), x = L(e.diffFile.getSplitLeftLine(e.index)), _ = L(e.diffFile.getSplitRightLine(e.index)), N = L(e.diffFile.getOldSyntaxLine((n = x.value) === null || n === void 0 ? void 0 : n.lineNumber)), S = L(e.diffFile.getNewSyntaxLine((i = _.value) === null || i === void 0 ? void 0 : i.lineNumber)), y = L(!!(!((d = x.value) === null || d === void 0) && d.diff) || !!(!((l = _.value) === null || l === void 0) && l.diff)), D = L(be((s = x.value) === null || s === void 0 ? void 0 : s.diff) || be((u = _.value) === null || u === void 0 ? void 0 : u.diff)), k = L(((a = x.value) === null || a === void 0 ? void 0 : a.isHidden) && ((v = _.value) === null || v === void 0 ? void 0 : v.isHidden)), H = L(((c = (o = x.value) === null || o === void 0 ? void 0 : o.diff) === null || c === void 0 ? void 0 : c.type) === C.Delete), G = L(((h = (f = _.value) === null || f === void 0 ? void 0 : f.diff) === null || h === void 0 ? void 0 : h.type) === C.Add);
  return U(e, (z) => {
    var q, ne, ie, pe, _e, Ie, Ne, te, le, mn, Ln, pn;
    x.value = z.getSplitLeftLine(e.index), _.value = z.getSplitRightLine(e.index), N.value = z.getOldSyntaxLine((q = x.value) === null || q === void 0 ? void 0 : q.lineNumber), S.value = z.getNewSyntaxLine((ne = _.value) === null || ne === void 0 ? void 0 : ne.lineNumber), y.value = !!(!((ie = x.value) === null || ie === void 0) && ie.diff) || !!(!((pe = _.value) === null || pe === void 0) && pe.diff), D.value = be((_e = x.value) === null || _e === void 0 ? void 0 : _e.diff) || be((Ie = _.value) === null || Ie === void 0 ? void 0 : Ie.diff), k.value = ((Ne = x.value) === null || Ne === void 0 ? void 0 : Ne.isHidden) && ((te = _.value) === null || te === void 0 ? void 0 : te.isHidden), H.value = ((mn = (le = x.value) === null || le === void 0 ? void 0 : le.diff) === null || mn === void 0 ? void 0 : mn.type) === C.Delete, G.value = ((pn = (Ln = _.value) === null || Ln === void 0 ? void 0 : Ln.diff) === null || pn === void 0 ? void 0 : pn.type) === C.Add;
  }), () => {
    var z, q;
    if (k.value)
      return null;
    const ne = !!(!((z = x.value) === null || z === void 0) && z.lineNumber), ie = !!(!((q = _.value) === null || q === void 0) && q.lineNumber), pe = kn(!1, H.value, y.value), _e = Hn(!1, H.value, y.value), Ie = kn(G.value, !1, y.value), Ne = Hn(G.value, !1, y.value);
    return t("tr", {
      "data-line": e.lineNumber,
      "data-state": y.value ? "diff" : "plain",
      class: "diff-line"
    }, [ne ? t(X, null, [t("td", {
      class: "diff-line-old-num group relative pl-[10px] pr-[10px] text-right align-top select-none w-[1%] min-w-[40px]",
      style: {
        backgroundColor: _e,
        color: `var(${ee})`
      }
    }, [y.value && m.value && t(en, {
      index: e.index,
      lineNumber: x.value.lineNumber,
      side: p.old,
      diffFile: e.diffFile,
      onWidgetClick: b,
      className: "absolute left-[100%] translate-x-[-50%] z-[1]",
      onOpenAddWidget: (te, le) => w({
        lineNumber: te,
        side: le
      })
    }, null), t("span", {
      "data-line-num": x.value.lineNumber,
      style: {
        opacity: D.value ? void 0 : 0.5
      }
    }, [x.value.lineNumber])]), t("td", {
      class: "diff-line-old-content group relative pr-[10px] align-top",
      style: {
        backgroundColor: pe
      },
      "data-side": p[p.old]
    }, [y.value && m.value && t(en, {
      index: e.index,
      lineNumber: x.value.lineNumber,
      side: p.old,
      diffFile: e.diffFile,
      onWidgetClick: b,
      className: "absolute right-[100%] translate-x-[50%] z-[1] select-none",
      onOpenAddWidget: (te, le) => w({
        lineNumber: te,
        side: le
      })
    }, null), t(Ge, {
      enableWrap: !0,
      diffFile: e.diffFile,
      rawLine: x.value.value,
      diffLine: x.value.diff,
      syntaxLine: N.value,
      enableHighlight: g.value
    }, null)])]) : t("td", {
      class: "diff-line-old-placeholder select-none",
      style: {
        backgroundColor: `var(${xe})`
      },
      colspan: 2
    }, [t("span", null, [$(" ")])]), ie ? t(X, null, [t("td", {
      class: "diff-line-new-num group relative pl-[10px] pr-[10px] text-right align-top select-none w-[1%] min-w-[40px] border-l-[1px] border-l-[rgb(222,222,222)]",
      style: {
        backgroundColor: Ne,
        color: `var(${ee})`
      }
    }, [y.value && m.value && t(en, {
      index: e.index,
      lineNumber: _.value.lineNumber,
      side: p.new,
      diffFile: e.diffFile,
      onWidgetClick: b,
      className: "absolute left-[100%] translate-x-[-50%] z-[1]",
      onOpenAddWidget: (te, le) => w({
        lineNumber: te,
        side: le
      })
    }, null), t("span", {
      "data-line-num": _.value.lineNumber,
      style: {
        opacity: D.value ? void 0 : 0.5
      }
    }, [_.value.lineNumber])]), t("td", {
      class: "diff-line-new-content group relative pr-[10px] align-top",
      style: {
        backgroundColor: Ie
      },
      "data-side": p[p.new]
    }, [y.value && m.value && t(en, {
      index: e.index,
      lineNumber: _.value.lineNumber,
      side: p.new,
      diffFile: e.diffFile,
      onWidgetClick: b,
      className: "absolute right-[100%] translate-x-[50%] z-[1] select-none",
      onOpenAddWidget: (te, le) => w({
        lineNumber: te,
        side: le
      })
    }, null), t(Ge, {
      enableWrap: !0,
      diffFile: e.diffFile,
      rawLine: _.value.value || "",
      diffLine: _.value.diff,
      syntaxLine: S.value,
      enableHighlight: g.value
    }, null)])]) : t("td", {
      class: "diff-line-new-placeholder border-l-[1px] border-l-[rgb(222,222,222)] select-none",
      style: {
        backgroundColor: `var(${xe})`
      },
      colspan: 2
    }, [t("span", null, [$(" ")])])]);
  };
}, {
  name: "DiffSplitLine",
  props: ["diffFile", "index", "lineNumber"]
}), wt = /* @__PURE__ */ M((e) => {
  const n = ze(), i = Mn(), d = Ze(), l = L(e.diffFile.getSplitLeftLine(e.index)), s = L(e.diffFile.getSplitRightLine(e.index)), u = F(() => l.value.lineNumber && i.value.side === p.old && i.value.lineNumber === l.value.lineNumber), a = F(() => s.value.lineNumber && i.value.side === p.new && i.value.lineNumber === s.value.lineNumber);
  U(e, (c) => {
    l.value = c.getSplitLeftLine(e.index), s.value = c.getSplitRightLine(e.index);
  });
  const v = F(() => !!u.value || !!a.value), o = () => d({});
  return () => {
    var c, f;
    return !v.value || !n.widget ? null : t("tr", {
      "data-line": `${e.lineNumber}-widget`,
      "data-state": "widget",
      class: "diff-line diff-line-widget"
    }, [u.value ? t("td", {
      class: "diff-line-widget-old-content p-0",
      colspan: 2
    }, [t("div", {
      class: "diff-line-widget-wrapper"
    }, [(c = n.widget) === null || c === void 0 ? void 0 : c.call(n, {
      diffFile: e.diffFile,
      side: p.old,
      lineNumber: l.value.lineNumber,
      onClose: o
    })])]) : t("td", {
      class: "diff-line-widget-old-placeholder p-0 select-none",
      style: {
        backgroundColor: `var(${xe})`
      },
      colspan: 2
    }, [t("span", null, [$(" ")])]), a.value ? t("td", {
      class: "diff-line-widget-new-content p-0 border-l-[1px] border-l-[rgb(222,222,222)]",
      colspan: 2
    }, [t("div", {
      class: "diff-line-widget-wrapper"
    }, [(f = n.widget) === null || f === void 0 ? void 0 : f.call(n, {
      diffFile: e.diffFile,
      side: p.new,
      lineNumber: s.value.lineNumber,
      onClose: o
    })])]) : t("td", {
      class: "diff-line-widget-new-placeholder p-0 border-l-[1px] border-l-[rgb(222,222,222)] select-none",
      style: {
        backgroundColor: `var(${xe})`
      },
      colspan: 2
    }, [t("span", null, [$(" ")])])]);
  };
}, {
  name: "DiffSplitWidgetLine",
  props: ["diffFile", "index", "lineNumber"]
}), mt = ({
  splitSideInfo: e,
  id: n
}) => t("style", {
  "data-select-style": !0
}, [e.side === p.old ? `#${n} td[data-side="${p[p.new]}"] {user-select: none}` : e.side === p.new ? `#${n} td[data-side="${p[p.old]}"] {user-select: none}` : ""]), Lt = /* @__PURE__ */ M((e) => {
  const n = L(vn(e.diffFile)), i = L(e.diffFile.splitLineLength.toString()), d = L({
    side: void 0
  }), l = (o) => {
    let c = o.target;
    if (c && c instanceof HTMLElement && c.nodeName === "BUTTON") {
      gn();
      return;
    }
    for (; c && c instanceof HTMLElement && c.nodeName !== "TD"; )
      c = c.parentElement;
    if (c instanceof HTMLElement) {
      const f = c.getAttribute("data-side");
      f && (d.value.side = p[f], gn());
    }
  }, s = En(), u = F(() => ({
    fontSize: s.value + "px",
    fontFamily: "Menlo, Consolas, monospace"
  }));
  U(e, (o) => {
    n.value = vn(o), i.value = o.splitLineLength.toString();
  });
  const a = Rn({
    text: i,
    font: u
  }), v = F(() => Math.max(40, a.value + 25));
  return () => t("div", {
    class: "split-diff-view split-diff-view-normal w-full"
  }, [t("div", {
    class: "diff-table-wrapper w-full",
    style: {
      fontFamily: "Menlo, Consolas, monospace",
      fontSize: `var(${J})`
    }
  }, [t(mt, {
    splitSideInfo: d.value,
    id: `diff-root${e.diffFile.getId()}`
  }, null), t("table", {
    class: "diff-table border-collapse table-fixed w-full"
  }, [t("colgroup", null, [t("col", {
    class: "diff-table-old-num-col",
    width: Math.round(v.value)
  }, null), t("col", {
    class: "diff-table-old-content-col"
  }, null), t("col", {
    class: "diff-table-new-num-col",
    width: Math.round(v.value)
  }, null), t("col", {
    class: "diff-table-new-content-col"
  }, null)]), t("thead", {
    class: "hidden"
  }, [t("tr", null, [t("th", {
    scope: "col"
  }, [$("old line number")]), t("th", {
    scope: "col"
  }, [$("old line content")]), t("th", {
    scope: "col"
  }, [$("new line number")]), t("th", {
    scope: "col"
  }, [$("new line content")])])]), t("tbody", {
    class: "diff-table-body leading-[1.4]",
    onMousedown: l
  }, [n.value.map((o) => t(X, {
    key: o.index
  }, [t(Zn, {
    index: o.index,
    lineNumber: o.lineNumber,
    diffFile: e.diffFile
  }, null), t(bt, {
    index: o.index,
    lineNumber: o.lineNumber,
    diffFile: e.diffFile
  }, null), t(wt, {
    index: o.index,
    lineNumber: o.lineNumber,
    diffFile: e.diffFile
  }, null), t(ht, {
    index: o.index,
    lineNumber: o.lineNumber,
    diffFile: e.diffFile
  }, null)])), t(Zn, {
    index: e.diffFile.splitLineLength,
    lineNumber: e.diffFile.splitLineLength,
    diffFile: e.diffFile
  }, null)])])])]);
}, {
  name: "DiffSplitViewWrap",
  props: ["diffFile"]
}), pt = /* @__PURE__ */ M((e) => {
  const n = Cn();
  return () => n.value ? t(Lt, {
    diffFile: e.diffFile
  }, null) : t(vt, {
    diffFile: e.diffFile
  }, null);
}, {
  name: "DiffSplitView",
  props: ["diffFile"]
}), _t = /* @__PURE__ */ M((e) => {
  var n, i, d, l;
  const s = Wn(), u = ze(), a = L(e.diffFile.getUnifiedLine(e.index)), v = L((i = (n = s.value) === null || n === void 0 ? void 0 : n.oldFile) === null || i === void 0 ? void 0 : i[a.value.oldLineNumber]), o = L((l = (d = s.value) === null || d === void 0 ? void 0 : d.newFile) === null || l === void 0 ? void 0 : l[a.value.newLineNumber]);
  U(e, (h) => {
    var w, m, g, b;
    a.value = h.getUnifiedLine(e.index), v.value = (m = (w = s.value) === null || w === void 0 ? void 0 : w.oldFile) === null || m === void 0 ? void 0 : m[a.value.oldLineNumber], o.value = (b = (g = s.value) === null || g === void 0 ? void 0 : g.newFile) === null || b === void 0 ? void 0 : b[a.value.newLineNumber];
  });
  const c = F(() => !!((v.value || o.value) && !a.value.isHidden && a.value.diff)), f = bn({
    selector: L(".unified-diff-table-wrapper"),
    enable: c
  });
  return () => c.value ? t("tr", {
    "data-line": `${e.lineNumber}-extend`,
    "data-state": "extend",
    class: "diff-line diff-line-extend"
  }, [t("td", {
    class: "diff-line-extend-content align-top p-0",
    colspan: 2
  }, [t("div", {
    class: "diff-line-extend-wrapper sticky left-0",
    style: {
      width: f.value + "px"
    }
  }, [f.value > 0 && v.value && u.extend({
    diffFile: e.diffFile,
    side: p.old,
    lineNumber: a.value.oldLineNumber,
    data: v.value.data,
    onUpdate: e.diffFile.notifyAll
  }), f.value > 0 && o.value && u.extend({
    diffFile: e.diffFile,
    side: p.new,
    lineNumber: a.value.newLineNumber,
    data: o.value.data,
    onUpdate: e.diffFile.notifyAll
  })])])]) : null;
}, {
  name: "DiffUnifiedExtendLine",
  props: ["diffFile", "index", "lineNumber"]
}), qn = /* @__PURE__ */ M((e) => {
  const n = L(e.diffFile.getUnifiedHunkLine(e.index)), i = L(e.diffFile.getExpandEnabled()), d = F(() => i.value && n.value && n.value.unifiedInfo), l = Cn(), s = L(n.value && n.value.unifiedInfo && n.value.unifiedInfo.startHiddenIndex < n.value.unifiedInfo.endHiddenIndex), u = L(n.value && n.value.unifiedInfo && n.value.unifiedInfo.endHiddenIndex - n.value.unifiedInfo.startHiddenIndex < E), a = L(n.value && n.value.index === 0), v = L(n.value && !n.value.unifiedInfo), o = L(n.value && n.value.isLast);
  return U(e, (c) => {
    n.value = c.getUnifiedHunkLine(e.index), i.value = c.getExpandEnabled(), s.value = n.value && n.value.unifiedInfo && n.value.unifiedInfo.startHiddenIndex < n.value.unifiedInfo.endHiddenIndex, u.value = n.value && n.value.unifiedInfo && n.value.unifiedInfo.endHiddenIndex - n.value.unifiedInfo.startHiddenIndex < E, a.value = n.value && n.value.index === 0, o.value = n.value && n.value.isLast, v.value = n.value && c._getIsPureDiffRender() && !n.value.unifiedInfo;
  }), () => {
    var c;
    return !s.value && !v.value ? null : t("tr", {
      "data-line": `${e.lineNumber}-hunk`,
      "data-state": "hunk",
      class: "diff-line diff-line-hunk"
    }, [t("td", {
      class: "diff-line-hunk-action sticky left-0 w-[1%] min-w-[100px] select-none",
      style: {
        backgroundColor: `var(${Pe})`,
        color: `var(${ee})`,
        width: `calc(calc(var(${A}) + 5px) * 2)`,
        maxWidth: `calc(calc(var(${A}) + 5px) * 2)`,
        minWidth: `calc(calc(var(${A}) + 5px) * 2)`
      }
    }, [d.value ? a.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand Up",
      "data-title": "Expand Up",
      onClick: () => e.diffFile.onUnifiedHunkExpand("up", e.index)
    }, [t(Y, {
      className: "fill-current"
    }, null)]) : o.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand Down",
      "data-title": "Expand Down",
      onClick: () => e.diffFile.onUnifiedHunkExpand("down", e.index)
    }, [t(Q, {
      className: "fill-current"
    }, null)]) : u.value ? t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[6px] cursor-pointer rounded-[2px]",
      title: "Expand All",
      "data-title": "Expand All",
      onClick: () => e.diffFile.onUnifiedHunkExpand("all", e.index)
    }, [t(Ve, {
      className: "fill-current"
    }, null)]) : t(X, null, [t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[2px] cursor-pointer rounded-[2px]",
      title: "Expand Down",
      "data-title": "Expand Down",
      onClick: () => e.diffFile.onUnifiedHunkExpand("down", e.index)
    }, [t(Q, {
      className: "fill-current"
    }, null)]), t("button", {
      class: "w-full diff-widget-tooltip hover:bg-blue-300 flex justify-center items-center py-[2px] cursor-pointer rounded-[2px]",
      title: "Expand Up",
      "data-title": "Expand Up",
      onClick: () => e.diffFile.onUnifiedHunkExpand("up", e.index)
    }, [t(Y, {
      className: "fill-current"
    }, null)])]) : t("div", {
      class: "min-h-[28px]"
    }, [$(" ")])]), t("td", {
      class: "diff-line-hunk-content pr-[10px] align-middle",
      style: {
        backgroundColor: `var(${ge})`
      }
    }, [t("div", {
      class: "pl-[1.5em]",
      style: {
        whiteSpace: l.value ? "pre-wrap" : "pre",
        wordBreak: l.value ? "break-all" : "initial",
        color: `var(${Ue})`
      }
    }, [((c = n.value.unifiedInfo) === null || c === void 0 ? void 0 : c.plainText) || n.value.text])])]);
  };
}, {
  name: "DiffUnifiedHunkLine",
  props: ["index", "diffFile", "lineNumber"]
}), It = ({
  index: e,
  diffLine: n,
  rawLine: i,
  syntaxLine: d,
  lineNumber: l,
  diffFile: s,
  enableWrap: u,
  enableAddWidget: a,
  enableHighlight: v,
  onOpenAddWidget: o,
  onAddWidgetClick: c
}) => t("tr", {
  "data-line": e,
  "data-state": "diff",
  class: "diff-line group"
}, [t("td", {
  class: "diff-line-num sticky left-0 pl-[10px] pr-[10px] text-right select-none w-[1%] min-w-[100px] whitespace-nowrap align-top",
  style: {
    color: `var(${ee})`,
    backgroundColor: `var(${Fi})`,
    width: `calc(calc(var(${A}) + 5px) * 2)`,
    maxWidth: `calc(calc(var(${A}) + 5px) * 2)`,
    minWidth: `calc(calc(var(${A}) + 5px) * 2)`
  }
}, [a && t(On, {
  index: e - 1,
  lineNumber: l,
  diffFile: s,
  side: p.old,
  onWidgetClick: c,
  onOpenAddWidget: o
}, null), t("div", {
  class: "flex"
}, [t("span", {
  "data-line-old-num": l,
  class: "inline-block w-[50%]"
}, [l]), t("span", {
  class: "w-[10px] shrink-0"
}, null), t("span", {
  class: "inline-block w-[50%]"
}, null)])]), t("td", {
  class: "diff-line-content pr-[10px] align-top",
  style: {
    backgroundColor: `var(${Ni})`
  }
}, [t(Ge, {
  enableWrap: u,
  diffFile: s,
  enableHighlight: v,
  rawLine: i,
  diffLine: n,
  syntaxLine: d
}, null)])]), Nt = ({
  index: e,
  diffLine: n,
  rawLine: i,
  syntaxLine: d,
  lineNumber: l,
  diffFile: s,
  enableWrap: u,
  enableAddWidget: a,
  enableHighlight: v,
  onOpenAddWidget: o,
  onAddWidgetClick: c
}) => t("tr", {
  "data-line": e,
  "data-state": "diff",
  class: "diff-line group"
}, [t("td", {
  class: "diff-line-num sticky left-0 pl-[10px] pr-[10px] text-right select-none w-[1%] min-w-[100px] whitespace-nowrap align-top",
  style: {
    color: `var(${ee})`,
    backgroundColor: `var(${yi})`,
    width: `calc(calc(var(${A}) + 5px) * 2)`,
    maxWidth: `calc(calc(var(${A}) + 5px) * 2)`,
    minWidth: `calc(calc(var(${A}) + 5px) * 2)`
  }
}, [a && t(On, {
  index: e - 1,
  lineNumber: l,
  diffFile: s,
  side: p.new,
  onWidgetClick: c,
  onOpenAddWidget: o
}, null), t("div", {
  class: "flex"
}, [t("span", {
  class: "inline-block w-[50%]"
}, null), t("span", {
  class: "shrink-0 w-[10px]"
}, null), t("span", {
  "data-line-new-num": l,
  class: "inline-block w-[50%]"
}, [l])])]), t("td", {
  class: "diff-line-content pr-[10px] align-top",
  style: {
    backgroundColor: `var(${Ii})`
  }
}, [t(Ge, {
  enableWrap: u,
  diffFile: s,
  enableHighlight: v,
  rawLine: i,
  diffLine: n,
  syntaxLine: d
}, null)])]), yt = /* @__PURE__ */ M((e) => {
  var n, i, d, l;
  const s = L(e.diffFile.getUnifiedLine(e.index)), u = Cn(), a = Ze(), v = An(), o = Dn(), c = $n(), f = L((n = s.value) === null || n === void 0 ? void 0 : n.isHidden), h = L(be((i = s.value) === null || i === void 0 ? void 0 : i.diff)), w = L(!((d = s.value) === null || d === void 0) && d.newLineNumber ? e.diffFile.getNewSyntaxLine(s.value.newLineNumber) : !((l = s.value) === null || l === void 0) && l.oldLineNumber ? e.diffFile.getOldSyntaxLine(s.value.oldLineNumber) : void 0);
  U(e, (g) => {
    var b, x, _, N;
    s.value = g.getUnifiedLine(e.index), w.value = !((b = s.value) === null || b === void 0) && b.newLineNumber ? g.getNewSyntaxLine(s.value.newLineNumber) : !((x = s.value) === null || x === void 0) && x.oldLineNumber ? g.getOldSyntaxLine(s.value.oldLineNumber) : void 0, f.value = (_ = s.value) === null || _ === void 0 ? void 0 : _.isHidden, h.value = be((N = s.value) === null || N === void 0 ? void 0 : N.diff);
  });
  const m = (g, b) => a({
    side: b,
    lineNumber: g
  });
  return () => f.value ? null : h.value ? s.value.oldLineNumber ? t(It, {
    index: e.lineNumber,
    enableWrap: u.value,
    diffFile: e.diffFile,
    rawLine: s.value.value || "",
    diffLine: s.value.diff,
    syntaxLine: w.value,
    enableHighlight: o.value,
    enableAddWidget: c.value,
    lineNumber: s.value.oldLineNumber,
    onAddWidgetClick: v,
    onOpenAddWidget: m
  }, null) : t(Nt, {
    index: e.lineNumber,
    enableWrap: u.value,
    diffFile: e.diffFile,
    rawLine: s.value.value || "",
    diffLine: s.value.diff,
    syntaxLine: w.value,
    enableHighlight: o.value,
    enableAddWidget: c.value,
    lineNumber: s.value.newLineNumber,
    onAddWidgetClick: v,
    onOpenAddWidget: m
  }, null) : t("tr", {
    "data-line": e.lineNumber,
    "data-state": s.value.diff ? "diff" : "plain",
    class: "diff-line group"
  }, [t("td", {
    class: "diff-line-num sticky left-0 pl-[10px] pr-[10px] text-right select-none w-[1%] min-w-[100px] whitespace-nowrap align-top",
    style: {
      color: `var(${ee})`,
      backgroundColor: s.value.diff ? `var(${ki})` : `var(${hn})`,
      width: `calc(calc(var(${A}) + 5px) * 2)`,
      maxWidth: `calc(calc(var(${A}) + 5px) * 2)`,
      minWidth: `calc(calc(var(${A}) + 5px) * 2)`
    }
  }, [c.value && s.value.diff && t(On, {
    index: e.index,
    diffFile: e.diffFile,
    lineNumber: s.value.newLineNumber,
    side: p.new,
    onOpenAddWidget: m,
    onWidgetClick: v
  }, null), t("div", {
    class: "flex opacity-[0.5]"
  }, [t("span", {
    "data-line-old-num": s.value.oldLineNumber,
    class: "inline-block w-[50%]"
  }, [s.value.oldLineNumber]), t("span", {
    class: "w-[10px] shrink-0"
  }, null), t("span", {
    "data-line-new-num": s.value.newLineNumber,
    class: "inline-block w-[50%]"
  }, [s.value.newLineNumber])])]), t("td", {
    class: "diff-line-content pr-[10px] align-top",
    style: {
      backgroundColor: s.value.diff ? `var(${Si})` : `var(${hn})`
    }
  }, [t(Ge, {
    enableWrap: u.value,
    diffFile: e.diffFile,
    enableHighlight: o.value,
    rawLine: s.value.value || "",
    diffLine: s.value.diff,
    syntaxLine: w.value
  }, null)])]);
}, {
  name: "DiffUnifiedLine",
  props: ["diffFile", "index", "lineNumber"]
}), Ft = /* @__PURE__ */ M((e) => {
  const n = ze(), i = Mn(), d = Ze(), l = L(e.diffFile.getUnifiedLine(e.index)), s = F(() => {
    var c;
    return ((c = l.value) === null || c === void 0 ? void 0 : c.oldLineNumber) && i.value.side === p.old && i.value.lineNumber === l.value.oldLineNumber;
  }), u = F(() => {
    var c;
    return ((c = l.value) === null || c === void 0 ? void 0 : c.newLineNumber) && i.value.side === p.new && i.value.lineNumber === l.value.newLineNumber;
  });
  U(e, (c) => l.value = c.getUnifiedLine(e.index));
  const a = F(() => (s.value || u.value) && !!n.widget), v = () => d({}), o = bn({
    selector: L(".unified-diff-table-wrapper"),
    enable: a
  });
  return () => {
    var c, f;
    return a.value ? t("tr", {
      "data-line": `${e.lineNumber}-widget`,
      "data-state": "widget",
      class: "diff-line diff-line-widget"
    }, [t("td", {
      class: "diff-line-widget-content p-0",
      colspan: 2
    }, [t("div", {
      class: "diff-line-widget-wrapper sticky left-0",
      style: {
        width: o.value + "px"
      }
    }, [o.value > 0 && s.value && ((c = n.widget) === null || c === void 0 ? void 0 : c.call(n, {
      diffFile: e.diffFile,
      side: p.old,
      lineNumber: l.value.oldLineNumber,
      onClose: v
    })), o.value > 0 && u.value && ((f = n.widget) === null || f === void 0 ? void 0 : f.call(n, {
      diffFile: e.diffFile,
      side: p.new,
      lineNumber: l.value.newLineNumber,
      onClose: v
    }))])])]) : null;
  };
}, {
  name: "DiffUnifiedWidgetLine",
  props: ["diffFile", "index", "lineNumber"]
}), St = (e) => {
  const n = e.target;
  if (n && n instanceof HTMLElement && n.nodeName === "BUTTON") {
    gn();
    return;
  }
}, kt = /* @__PURE__ */ M((e) => {
  const n = L(Vn(e.diffFile)), i = L(e.diffFile.unifiedLineLength.toString());
  U(e, (a) => {
    n.value = Vn(a), i.value = a.splitLineLength.toString();
  });
  const d = En(), l = F(() => ({
    fontSize: d.value + "px",
    fontFamily: "Menlo, Consolas, monospace"
  })), s = Rn({
    text: i,
    font: l
  }), u = F(() => Math.max(40, s.value + 25));
  return () => t("div", {
    class: "unified-diff-view w-full"
  }, [t("div", {
    class: "unified-diff-table-wrapper overflow-x-auto overflow-y-hidden w-full scrollbar-hide",
    style: {
      [A]: `${Math.round(u.value)}px`,
      fontFamily: "Menlo, Consolas, monospace",
      fontSize: `var(${J})`
    }
  }, [t("table", {
    class: "unified-diff-table border-collapse w-full"
  }, [t("colgroup", null, [t("col", {
    class: "unified-diff-table-num-col"
  }, null), t("col", {
    class: "unified-diff-table-content-col"
  }, null)]), t("thead", {
    class: "hidden"
  }, [t("tr", null, [t("th", {
    scope: "col"
  }, [$("line number")]), t("th", {
    scope: "col"
  }, [$("line content")])])]), t("tbody", {
    class: "diff-table-body leading-[1.4]",
    onMousedown: St
  }, [n.value.map((a) => t(X, {
    key: a.index
  }, [t(qn, {
    index: a.index,
    lineNumber: a.lineNumber,
    diffFile: e.diffFile
  }, null), t(yt, {
    index: a.index,
    lineNumber: a.lineNumber,
    diffFile: e.diffFile
  }, null), t(Ft, {
    index: a.index,
    lineNumber: a.lineNumber,
    diffFile: e.diffFile
  }, null), t(_t, {
    index: a.index,
    lineNumber: a.lineNumber,
    diffFile: e.diffFile
  }, null)])), t(qn, {
    index: e.diffFile.unifiedLineLength,
    lineNumber: e.diffFile.unifiedLineLength,
    diffFile: e.diffFile
  }, null)])])])]);
}, {
  props: ["diffFile"],
  name: "DiffUnifiedView"
});
var oe;
(function(e) {
  e[e.SplitGitHub = 1] = "SplitGitHub", e[e.SplitGitLab = 2] = "SplitGitLab", e[e.Split = 3] = "Split", e[e.Unified = 4] = "Unified";
})(oe || (oe = {}));
var p;
(function(e) {
  e[e.old = 1] = "old", e[e.new = 2] = "new";
})(p || (p = {}));
et.name = "@git-diff-view/vue";
const J = "--diff-font-size--", Dt = /* @__PURE__ */ M((e, n) => {
  var i, d;
  const l = () => {
    var g, b, x, _, N, S;
    if (e.diffFile) {
      const y = cn.createInstance({});
      return y._mergeFullBundle(e.diffFile._getFullBundle()), y;
    }
    return e.data ? new cn(((g = e.data.oldFile) === null || g === void 0 ? void 0 : g.fileName) || "", ((b = e.data.oldFile) === null || b === void 0 ? void 0 : b.content) || "", ((x = e.data.newFile) === null || x === void 0 ? void 0 : x.fileName) || "", ((_ = e.data.newFile) === null || _ === void 0 ? void 0 : _.content) || "", e.data.hunks || [], ((N = e.data.oldFile) === null || N === void 0 ? void 0 : N.fileLang) || "", ((S = e.data.newFile) === null || S === void 0 ? void 0 : S.fileLang) || "") : null;
  }, s = L(l()), u = L((d = (i = s.value) === null || i === void 0 ? void 0 : i.getId) === null || d === void 0 ? void 0 : d.call(i)), a = L({}), v = (g) => {
    typeof n.slots.widget == "function" && (a.value = g);
  }, o = F(() => {
    var g;
    return (g = e.diffViewHighlight) !== null && g !== void 0 ? g : !0;
  });
  sn(() => e.diffFile, () => {
    var g, b;
    (b = (g = s.value) === null || g === void 0 ? void 0 : g._destroy) === null || b === void 0 || b.call(g), s.value = l();
  }, {
    immediate: !0
  }), sn(() => e.data, () => {
    var g, b;
    (b = (g = s.value) === null || g === void 0 ? void 0 : g._destroy) === null || b === void 0 || b.call(g), s.value = l();
  }, {
    immediate: !0,
    deep: !0
  }), sn(() => s.value, () => a.value = {});
  const c = ln(), f = (g) => {
    if (!c.value || !s.value || !e.diffFile)
      return;
    const b = s.value;
    e.diffFile._addClonedInstance(b), g(() => e.diffFile._delClonedInstance(b));
  }, h = () => {
    if (!c.value || !s.value)
      return;
    const g = s.value;
    g.initRaw(), g.buildSplitDiffLines(), g.buildUnifiedDiffLines();
  }, w = () => {
    if (!c.value || !o.value || !s.value)
      return;
    const g = s.value;
    g.initSyntax({
      registerHighlighter: e.registerHighlighter
    }), g.notifyAll();
  }, m = (g) => {
    if (!s.value)
      return;
    const b = s.value;
    u.value = b.getId(), g(() => b.clearId());
  };
  return qe(() => h()), qe(() => w()), qe((g) => m(g)), qe((g) => f(g)), We(ui, u), We(gi, n.slots), We(bi, n.emit), We(wi, a), We(mi, v), $e(e, "diffViewMode", fi, {
    defaultValue: oe.SplitGitHub
  }), $e(e, "diffViewFontSize", ri, {
    defaultValue: 14
  }), $e(e, "diffViewWrap", ci), $e(e, "diffViewHighlight", vi), $e(e, "diffViewAddWidget", hi), $e(e, "extendData", xi, {
    deepWatch: !0
  }), Mi(() => {
    var g, b;
    return (b = (g = s.value)._destroy) === null || b === void 0 ? void 0 : b.call(g);
  }), n.expose({
    getDiffFileInstance: () => s.value
  }), () => s.value ? t("div", {
    class: "diff-tailwindcss-wrapper",
    "data-component": "git-diff-view",
    "data-version": "0.0.12",
    "data-highlighter": s.value._getHighlighterName()
  }, [t("div", {
    class: "diff-style-root",
    style: {
      [J]: (e.diffViewFontSize || 14) + "px"
    }
  }, [t("div", {
    id: `diff-root${u.value}`,
    class: "diff-view-wrapper" + (e.class ? ` ${e.class}` : ""),
    style: e.style
  }, [!e.diffViewMode || e.diffViewMode & oe.Split ? t(pt, {
    key: oe.Split,
    diffFile: s.value
  }, null) : t(kt, {
    key: oe.Unified,
    diffFile: s.value
  }, null)])])]) : null;
}, {
  name: "DiffView",
  props: ["data", "class", "diffFile", "diffViewAddWidget", "diffViewFontSize", "diffViewHighlight", "diffViewMode", "diffViewWrap", "extendData", "registerHighlighter", "style"],
  // expose: ["getDiffView"],
  slots: Object
}), $t = "0.0.12";
export {
  Pi as DefaultDiffExpansionStep,
  cn as DiffFile,
  Z as DiffFileLineType,
  ji as DiffHunk,
  je as DiffHunkExpansionType,
  Bi as DiffHunkHeader,
  ve as DiffLine,
  C as DiffLineType,
  oe as DiffModeEnum,
  Xi as DiffParser,
  Dt as DiffView,
  tn as File,
  qi as HiddenBidiCharsRegex,
  T as NewLineSymbol,
  p as SplitSide,
  et as _cacheMap,
  Vi as assertNever,
  be as checkDiffLineIncludeChange,
  E as composeLen,
  J as diffFontSizeName,
  Pn as getDiffRange,
  De as getFile,
  zi as getHunkHeaderExpansionType,
  Un as getLang,
  Gi as getLargestLineNumber,
  vn as getSplitContentLines,
  nt as getSplitLines,
  Vn as getUnifiedContentLine,
  it as getUnifiedLines,
  Ui as hasRelativeChange,
  ii as highlighter,
  Xn as numIterator,
  Ji as parseInstance,
  Qi as processAST,
  Kn as relativeChanges,
  $t as version,
  Ct as versions
};
//# sourceMappingURL=vue-git-diff-view.mjs.map
